/*
1.HW monitor test code

2.use guide:
add following code in *.inc

##Config_RTD_HW_MONITOR [ TRUE | FALSE ]
Config_RTD_HW_MONITOR = TRUE

 */

#include <common.h>
#include <command.h>
#include <asm/arch/system.h>
#include <rbus/stb_reg.h>
#include "cmd_av_jump.h"


extern uint *AudioFW_entry_ptr_A1;
extern uint *VideoFW_entry_ptr_V1;
#if 0
extern uint *AudioFW_entry_ptr_A2;
extern uint *VideoFW_entry_ptr_V2;
#endif
extern uint *KcpuFlag_ptr;

#define AudioFW_Read_Test_Addr ((volatile uint*)0xd0)
#define VideoFW_Read_Test_Addr ((volatile uint*)0xd4)
#define Audio2FW_Read_Test_Addr ((volatile uint*)0x78)
#define Video2FW_Read_Test_Addr ((volatile uint*)0xd8)

#define FW_RW_Share_Status_Addr *((volatile uint*)0xe8)

#define KCPU_WAIT_JUMP_DUMMY_REG  0x18060124
#define KCPUFW_Read_Test_Addr   ((volatile uint*)0x1801a608)
extern uint *KcpuFlag_ptr;
//Above Macros only used for hw monitors Ip test condition, will not affect a/v cpu normal boot flow


#define BYTE(d,n)       (((d) >> ((n) << 3)) & 0xFF)
#define SWAPEND32(d)    ((BYTE(d,0) << 24) | (BYTE(d,1) << 16) | (BYTE(d,2) << 8) | (BYTE(d,3) << 0))


#define REG32( addr )         (*(volatile uint *)(addr))
#define avk_rtd_outl(addr, val) (REG32(addr) = (uint)val)


#define MIPS_KSEG1BASE  0xa0000000
#define  SB2_HD_SEM   0x1801A000

#define RW_FLAG_RO      1
#define RW_FLAG_WO      2

void flush_dcache_all(void);

static int flag_acpu1 = 1;
static int flag_vcpu1 = 1;
#if 0
static int flag_kcpu = 1;
static int flag_acpu2 = 1;
static int flag_vcpu2 = 1;

//read address value is saved at VideoFW_Read_Test_Addr
int vcpu2_rtd_api (unsigned int addr, int rw)
{
        int vcpu2_rw_bit = rw; 
        if (flag_vcpu2) {
                enable_video2_clock();

                //let vcpu2 run the test flow
                *VideoFW_entry_ptr_V2 = SWAPEND32((uint)V2_ENTRY_IMAGE_ENTRY | MIPS_KSEG1BASE);
                flush_dcache_all();

                //rtd_outl(SB2_HD_SEM, 0x1);//hold_hw_semaphore
                rtd_outl(SB2_HD_SEM, 0x0);//release_hw_semaphore

                flush_dcache_all();
                mdelay(100);
                flag_vcpu2 = 0;
                printf("\n");

        }
        FW_RW_Share_Status_Addr = SWAPEND32(vcpu2_rw_bit);
        *VideoFW_entry_ptr_V2 = SWAPEND32(addr | MIPS_KSEG1BASE);
        //*VideoFW_entry_ptr_V2 = SWAPEND32(addr);        // for DBUS range access
        flush_dcache_all();
        mdelay(50);
        printf(" address is 0x%08x \n", addr);
        if(rw == RW_FLAG_RO) {
                return SWAPEND32(*Video2FW_Read_Test_Addr);
        }

        return 0;

}



//read address value is saved at AudioFW_Read_Test_Addr
int acpu2_rtd_api (unsigned int addr, int rw)
{
        int acpu2_rw_bit = rw; 
        if (flag_acpu2) {
                enable_audio2_clock();

                //let acpu2 run the test flow
                *AudioFW_entry_ptr_A2 = SWAPEND32((uint)A2_ENTRY_IMAGE_ENTRY | MIPS_KSEG1BASE);
                flush_dcache_all();

                //rtd_outl(SB2_HD_SEM, 0x1);//hold_hw_semaphore
                rtd_outl(SB2_HD_SEM, 0x0);//release_hw_semaphore

                flush_dcache_all();
                mdelay(100);

                flag_acpu2 = 0;
                printf("\n");

        }
        FW_RW_Share_Status_Addr = SWAPEND32(acpu2_rw_bit);
        *AudioFW_entry_ptr_A2 = SWAPEND32(addr | MIPS_KSEG1BASE);
        //*AudioFW_entry_ptr_A2 = SWAPEND32(addr);        // for DBUS range access
        flush_dcache_all();
        mdelay(50);
        printf(" address is 0x%08x \n", addr);
        if(rw == RW_FLAG_RO) {
                return SWAPEND32(*Audio2FW_Read_Test_Addr);
        }
        return 0;

}

//read address value is saved at KCPUFW_Read_Test_Addr
int kcpu_rtd_api_bak (unsigned int addr, int rw)
{
        int kcpu_rw_bit = rw - 1; //for vcpu, 0 means read, 1 means write
        if (flag_kcpu) {
			printf("@@@[%s][%d][%s]kcpu clk :0x18000110 = 0x%08x\n", __FILE__ ,__LINE__ ,__func__,rtd_inl(0xb8000110));
                //let kcpu run the k_entry.S
                //release kcpu
                rtd_outl(KCPU_WAIT_JUMP_DUMMY_REG, (uint)K_ENTRY_IMAGE_ENTRY | 0xa0000000);

                flush_dcache_all();
                mdelay(100);
                flag_kcpu = 0;
                printf("\n");
        }
        *KcpuFlag_ptr = kcpu_rw_bit;
        rtd_outl(KCPU_WAIT_JUMP_DUMMY_REG, (addr | 0xa0000000));
        flush_dcache_all();
        mdelay(50);
        printf(" address is 0x%08x \n", addr);
        return 0;

}

int kcpu_rtd_api (unsigned int addr, int rw)
{
        int kcpu_rw_bit = rw; 
        if (flag_kcpu) {
                //let kcpu run the k_entry.S
                //release kcpu
                rtd_outl(KCPU_WAIT_JUMP_DUMMY_REG, (uint)K_ENTRY_IMAGE_ENTRY | 0xa0000000);

                flush_dcache_all();
                mdelay(100);
                flag_kcpu = 0;
                printf("\n");
        }
        FW_RW_Share_Status_Addr = kcpu_rw_bit;
        rtd_outl(KCPU_WAIT_JUMP_DUMMY_REG, (addr | 0xa0000000));
        //rtd_outl(KCPU_WAIT_JUMP_DUMMY_REG, addr);     // for DBUS range access
        flush_dcache_all();
        mdelay(50);
        printf(" address is 0x%08x \n", addr);
        if(rw == RW_FLAG_RO) {
                return (*KcpuFlag_ptr);
        }
		
        return 0;

}
#endif

//read address value is saved at VideoFW_Read_Test_Addr
int vcpu_rtd_api (unsigned int addr, int rw)
{
        int vcpu_rw_bit = rw; 
        if (flag_vcpu1) {
                enable_video_clock();

                //let vcpu run the test flow
                *VideoFW_entry_ptr_V1 = SWAPEND32((uint)V1_ENTRY_IMAGE_ENTRY | MIPS_KSEG1BASE);
                flush_dcache_all();

                //rtd_outl(SB2_HD_SEM, 0x1);//hold_hw_semaphore
                rtd_outl(SB2_HD_SEM, 0x0);//release_hw_semaphore

                flush_dcache_all();
                mdelay(100);
                flag_vcpu1 = 0;
                printf("\n");

        }
        FW_RW_Share_Status_Addr = SWAPEND32(vcpu_rw_bit);
        *VideoFW_entry_ptr_V1 = SWAPEND32(addr | MIPS_KSEG1BASE);
        //*VideoFW_entry_ptr_V1 = SWAPEND32(addr);        // for DBUS range access
        flush_dcache_all();
        mdelay(50);
        printf(" address is 0x%08x \n", addr);
        if(rw == RW_FLAG_RO) {
                return SWAPEND32(*VideoFW_Read_Test_Addr);
        }

        return 0;

}



//read address value is saved at AudioFW_Read_Test_Addr
int acpu_rtd_api (unsigned int addr, int rw)
{
        int acpu_rw_bit = rw; 
        if (flag_acpu1) {
                enable_audio_clock();

                //let acpu run the test flow
                *AudioFW_entry_ptr_A1 = SWAPEND32((uint)A1_ENTRY_IMAGE_ENTRY | MIPS_KSEG1BASE);
                flush_dcache_all();

                //rtd_outl(SB2_HD_SEM, 0x1);//hold_hw_semaphore
                rtd_outl(SB2_HD_SEM, 0x0);//release_hw_semaphore

                flush_dcache_all();
                mdelay(100);

                flag_acpu1 = 0;
                printf("\n");

        }
        FW_RW_Share_Status_Addr = SWAPEND32(acpu_rw_bit);
        *AudioFW_entry_ptr_A1 = SWAPEND32(addr | MIPS_KSEG1BASE);
        //*AudioFW_entry_ptr_A1 = SWAPEND32(addr);      // for DBUS range access
        flush_dcache_all();
        mdelay(50);
        printf(" address is 0x%08x \n", addr);
        if(rw == RW_FLAG_RO) {
                return SWAPEND32(*AudioFW_Read_Test_Addr);
        }
        return 0;

}

#if 0
//read address value is saved at ddr KCPUFW_Read_Test_Addr
int do_kcpu_access(unsigned int addr)
{

        //read  OK condition:
        // the value in KCPUFW_Read_Test_Addr is changed to  0x66666666 from 0x55555555
        // the value in test_addr is still 0x66666666 after call acpu_rtd_api



        printf("\n@@@[%s][%d][%s]Kcpu read test begin\n", __FILE__ , __LINE__ , __func__);
        *((volatile uint*)addr) = 0x66666666;
        *KCPUFW_Read_Test_Addr = 0x55555555;
        printf("before kcpu access...KCPUFW_Read_Test_Addr(0x%x) = 0x%x\n", KCPUFW_Read_Test_Addr, *KCPUFW_Read_Test_Addr);
        printf("before kcpu access...Specify_Access_Addr(0x%x) = 0x%x\n", addr, *((uint*)addr));

        flush_dcache_all();
        mdelay(100);

        kcpu_rtd_api(addr, RW_FLAG_RO);

        flush_dcache_all();
        mdelay(100);
        printf("after kcpu access...KCPUFW_Read_Test_Addr(0x%x) = 0x%x\n", KCPUFW_Read_Test_Addr, *KCPUFW_Read_Test_Addr);
        printf("after kcpu access...Specify_Access_Addr(0x%x) = 0x%x\n", addr, *((uint*)addr));


        //write  OK condition:
        // the value in KCPUFW_Read_Test_Addr is still 0x33333333
        // the value in test_addr is changed to 0x78563412 from 0xdddddddd

        printf("\n@@@[%s][%d][%s]Kcpu write test begin\n", __FILE__ , __LINE__ , __func__);
        *((volatile uint*)addr) = 0xdddddddd;
        *KCPUFW_Read_Test_Addr = 0x33333333;
        printf("before kcpu access...KCPUFW_Read_Test_Addr(0x%x) = 0x%x\n", KCPUFW_Read_Test_Addr, *KCPUFW_Read_Test_Addr);
        printf("before kcpu access...Specify_Access_Addr(0x%x) = 0x%x\n", addr, *((uint*)addr));
        flush_dcache_all();
        mdelay(100);


        kcpu_rtd_api(addr, RW_FLAG_WO);
        flush_dcache_all();
        mdelay(100);

        printf("after kcpu access...KCPUFW_Read_Test_Addr(0x%x) = 0x%x\n", KCPUFW_Read_Test_Addr, *KCPUFW_Read_Test_Addr);
        printf("after kcpu access...Specify_Access_Addr(0x%x) = 0x%x\n", addr, *((uint*)addr));



}
#endif
int do_acpu_timeout_return_value_test(unsigned int addr)
{

        //read  OK condition:
        // the value in AudioFW_Read_Test_Addr is changed to  0x22222222 from 0x11111111
        // the value in test_addr is still 0x22222222 after call acpu_rtd_api

        printf("\n@@@[%s][%d][%s]Acpu read test begin\n", __FILE__ , __LINE__ , __func__);

        *AudioFW_Read_Test_Addr = 0x11111111;
        flush_dcache_all();
        mdelay(100);
        printf("before acpu access...AudioFW_Read_Test_Addr(0x%x) = 0x%x\n", (unsigned int)AudioFW_Read_Test_Addr, *AudioFW_Read_Test_Addr);


        acpu_rtd_api(addr, RW_FLAG_RO);

        flush_dcache_all();
        mdelay(100);

        printf("after acpu access...AudioFW_Read_Test_Addr(0x%x) = 0x%x\n", (unsigned int)AudioFW_Read_Test_Addr, *AudioFW_Read_Test_Addr);
        return 0;
}

int do_vcpu_timeout_return_value_test(unsigned int addr)
{

        //read  OK condition:
        // the value in AudioFW_Read_Test_Addr is changed to  0x22222222 from 0x11111111
        // the value in test_addr is still 0x22222222 after call acpu_rtd_api

        printf("\n@@@[%s][%d][%s]Vcpu read test begin\n", __FILE__ , __LINE__ , __func__);

        *VideoFW_Read_Test_Addr = 0x11111111;
        flush_dcache_all();
        mdelay(100);
        printf("before vcpu access...VideoFW_Read_Test_Addr(0x%x) = 0x%x\n", (unsigned int)VideoFW_Read_Test_Addr, *VideoFW_Read_Test_Addr);

        vcpu_rtd_api(addr, RW_FLAG_RO);

        flush_dcache_all();
        mdelay(100);

        printf("after vcpu access...VideoFW_Read_Test_Addr(0x%x) = 0x%x\n", (unsigned int)VideoFW_Read_Test_Addr, *VideoFW_Read_Test_Addr);
        return 0;
}
#if 0
int do_kcpu_timeout_return_value_test(unsigned int addr)
{

        //read  OK condition:
        // the value in AudioFW_Read_Test_Addr is changed to  0x22222222 from 0x11111111
        // the value in test_addr is still 0x22222222 after call acpu_rtd_api

        printf("\n@@@[%s][%d][%s]Kcpu read test begin\n", __FILE__ , __LINE__ , __func__);

        *KCPUFW_Read_Test_Addr = 0x11111111;
        flush_dcache_all();
        mdelay(100);
        printf("before kcpu access...KCPUFW_Read_Test_Addr(0x%x) = 0x%x\n", (unsigned int)KCPUFW_Read_Test_Addr, *KCPUFW_Read_Test_Addr);

        kcpu_rtd_api(addr, RW_FLAG_RO);

        flush_dcache_all();
        mdelay(100);

        printf("after kcpu access...KCPUFW_Read_Test_Addr(0x%x) = 0x%x\n", (unsigned int)KCPUFW_Read_Test_Addr, *KCPUFW_Read_Test_Addr);
        return 0;
}
#endif

//use for test a/v/k access action whether match our expectation
int do_avk_access ( cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{

        u32 addr = 0x100000;
        switch (argc) {
                case 2:
                        addr = simple_strtoul(argv[1], NULL, 16);
                        printf("@@@[%s][%d][%s]addr = 0x%x\n", __FILE__ , __LINE__ , __func__, addr);
                        break;
                case 1:
                        break;
                default:
                        return CMD_RET_USAGE;
        }
        printf("\n\n\n");
        //do_acpu_access(addr);
        printf("\n\n\n");
        //do_vcpu_access(addr);
        printf("\n\n\n");
        //do_kcpu_access(addr);
        printf("\n\n\n");

        //do_acpu_timeout_return_value_test(addr);
        do_vcpu_timeout_return_value_test(addr);
        //do_kcpu_timeout_return_value_test(addr);

        printf("\n\n\n");
        //printf("@@@[%s][%d][%s]A1_ENTRY_IMAGE_ENTRY = 0x%x\n", __FILE__ , __LINE__ , __func__, A1_ENTRY_IMAGE_ENTRY);
        //printf("@@@[%s][%d][%s]V1_ENTRY_IMAGE_ENTRY = 0x%x\n", __FILE__ , __LINE__ , __func__, V1_ENTRY_IMAGE_ENTRY);
        //printf("@@@[%s][%d][%s]K_ENTRY_IMAGE_ENTRY = 0x%x\n", __FILE__ , __LINE__ , __func__, K_ENTRY_IMAGE_ENTRY);
        return 0;


}

U_BOOT_CMD(
        avk_access,   2,   1,     do_avk_access,
        "avk_access",
        "[addr]\n"
        "    - let acpu1 access specified address"
);



