#include <common.h>
#include <u-boot/zlib.h>
#include <asm/byteorder.h>
#include <fdt.h>
#include <libfdt.h>
#include <fdt_support.h>
#include <asm/arch/fw_info.h>
#include <asm/arch/system.h>
#include <exports.h>
#include <environment.h>
#include <wakeup.h>
#include <asm/arch/system.h>
#include <asm/arch/fw_info.h>
#include <asm/arch/bootparam.h>
#include <platform_lib/board/pcb_mgr.h>
#include <watchdog.h>
#include <factorylib.h>
void CusApi_boot_prep_linux_for_standby(void)
{
}

void CusApi_boot_prep_linux_bootargs(void)
{
    char *commandline = NULL;
    char *tmp_cmdline = NULL;
    int len = 0;

    if(CONFIG_VIP_RESERVED_ADDR) {
        commandline = getenv("bootargs");
        len = strlen(commandline) + 32;
        tmp_cmdline = (char *)malloc(len);
        if (!tmp_cmdline) {
            printf("[ERR] %s: Malloc failed\n", __func__);
        }
        else {
            memset(tmp_cmdline, 0, len);

            sprintf(tmp_cmdline, "%s VIP=%dM@%dM", commandline,
			VIP_UBOOT_RESERVED_SIZE >> 20,
			VIP_UBOOT_RESERVED_ADDR >> 20
		);
            setenv("bootargs", tmp_cmdline);

            free(tmp_cmdline);
        }
    }

    if(CONFIG_OD_RESERVED_ADDR) {
        commandline = getenv("bootargs");
        len = strlen(commandline) + 32;
        tmp_cmdline = (char *)malloc(len);
        if (!tmp_cmdline) {
           printf("[ERR] %s: Malloc failed\n", __func__);
        }
        else {
            memset(tmp_cmdline, 0, len);

            sprintf(tmp_cmdline, "%s OD=%dM@%dM", commandline,
			OD_UBOOT_RESERVED_SIZE >> 20,
			OD_UBOOT_RESERVED_ADDR >> 20
           );
            setenv("bootargs", tmp_cmdline);

            free(tmp_cmdline);
        }
    }
}