#include <common.h>
#include <parse_h.h>
#include <asm/arch/bootparam.h>
#include <asm/arch/fw_info.h>
#include <asm/arch/system.h>
#include <exports.h>
#include <factorylib.h>
#include <platform_lib/board/pcb.h>

extern uchar boot_ac_on;
extern int boot_power_on_mode;
extern int prev_power_on_status;

#ifdef CONFIG_CUSTOM_SN_PANEL
#define BOOT_PARAM_FILE_NAME	FACTORY_HEADER_FILE_NAME"bin_panel/000BootParam.h"

extern void enable_console(void);
extern void disable_console(void);
#ifdef CONFIG_CUSTOM_PQ_SELECT
extern bool CusApi_env_writeEnvFile(char *pItemName, char *pParameter);
#endif

#define DEBUG_MODE 0
#define NORMAL_MODE 1

#endif

void CusApi_get_bootparam(char *dst_addr, int dst_length)
{
}


char CusApi_get_bootparam_PowerMode(void)
{

        char *dst_addr;
        char *retAddr;
        int dst_length;
        uint retVal;

        if(factory_read(BOOT_PARAM_FILE_NAME, &dst_addr, &dst_length))
            return 1;

        if(parse_h("POWER_ON_MODE", dst_addr, (uint)dst_length, &retVal, &retAddr))
            return 1;

        printf("POWER_ON_MODE = %d--\n",retVal);
        if(1 == retVal)
            return 1;
        else
            return 0;
}


char CusApi_get_bootparam_SHUTDOWN(void)
{

        char *dst_addr;
        char *retAddr;
        int dst_length;
        uint retVal;

        if(factory_read(BOOT_PARAM_FILE_NAME, &dst_addr, &dst_length))
            return 0;

        if(parse_h("SHUTDOWN_DISABLE", dst_addr, (uint)dst_length, &retVal, &retAddr))
            return 0;

        printf("SHUTDOWN_DISABLE = %d--\n",retVal);
        if(1 == retVal)
            return 1;
        else
            return 0;
}


void CusApi_decide_power_on_mode(void)
{
	// RTK config don't care prev_power_state and always power on
	boot_power_on_mode = POWER_ON;
	prev_power_on_status = bootparam.prev_power_state;

#if defined(CONFIG_BOOTUP_BY_PREV_POWER_STATUS) || defined(ENABLE_BOOTUP_POLICY)
	if(boot_ac_on)
		boot_power_on_mode = bootparam.prev_power_state;
#endif

#ifdef ENABLE_BOOTUP_POLICY
	printf("bootup_policy=%d\n", bootparam.bootup_policy);
	if(bootparam.bootup_policy != 2)	//0: always powerOff, 1: always powerOn, 2:auto by prev_status
	{
		if(boot_ac_on)
			boot_power_on_mode = bootparam.bootup_policy;
		else
			boot_power_on_mode = POWER_ON;
	}
#endif

}
