#define LEAF(name)			\
	.##text;				\
	.##global	name;		\
	.##ent		name;		\
name:

#define END(name)			\
	.##end	name

#define C0_PRId		$15

#define zero		$0
#define AT			$1
#define v0			$2
#define v1			$3
#define a0			$4
#define a1			$5
#define a2			$6
#define a3			$7
#define t0			$8
#define t1			$9
#define t2			$10
#define t3			$11
#define t4			$12
#define t5			$13
#define t6			$14
#define t7			$15
#define s0			$16
#define s1			$17
#define s2			$18
#define s3			$19
#define s4			$20
#define s5			$21
#define s6			$22
#define s7			$23
#define t8			$24
#define t9			$25
#define k0			$26
#define k1			$27
#define gp			$28
#define sp			$29
#define fp			$30
#define ra			$31

#define REG_UART0_BASE		0xb8062300
#define REG_UART1_BASE		0xb801b100
#define DEFAULT_UART		REG_UART1_BASE

#define PRID_CPU_LX_5281_A	0x025adc02
#define PRID_CPU_LX_5280_V	0x01a5c601

#define ACPU_JUMP_ADDR		0xb806012c	/* register which represent ACPU jump address (specified in Aux code or DTE Bootcode) */
#define VCPU_JUMP_ADDR		0xb801a61c	/* register which represent VCPU jump address (specified in Aux code or DTE Bootcode) */

/***************************************
 *
 *           __reset_vector
 *
 ***************************************/

LEAF(__reset_vector)
 	.set noreorder
	.set nomips16

	mfc0	k0, C0_PRId

	/* Determine if processor Audio 5281 CPU */
	li		k1, PRID_CPU_LX_5281_A
	beq		k1, k0, cpu_is_5280_a
	nop

/* 
 * VCPU wait HW semaphore in v_entry (in order to sync with NOR boot case)
 * v_entry should be put in DDR prior to enable VCPU clock
 */
cpu_is_5280_v:
	la		t0, VCPU_JUMP_ADDR
	b		jump_to_addr
	nop

/* 
 * ACPU wait HW semaphore in a_entry (in order to sync with NOR boot case)
 * a_entry should be put in DDR prior to enable ACPU clock
 */
cpu_is_5281_a:
cpu_is_5280_a:
	la		t0, ACPU_JUMP_ADDR
	b		jump_to_addr
	nop

jump_to_addr:
	lw		t1, 0(t0)
	jalr	t1	# should never return
	nop

err_handle:
	# should not return
	li		t0, 'x'
	sw		t0, DEFAULT_UART
	li		t0, 'X'
	sw		t0, DEFAULT_UART

hand_loop:
	b		hand_loop
	nop

END(__reset_vector)
