/*
 * Configuration settings for the Realtek Demo board.
 *
 * Won't include this file.
 * Just type "make <board_name>_config" and will be included in source tree.
 */

#ifndef __CONFIG_RTK_DEMO_H
#define __CONFIG_RTK_DEMO_H

// This config can be used only when the patch really can't follow customize api.
// So please try to find out the best solution when porting customer features.
// You can also discuss with boot/kernel team members for more suggestion.
#define CONFIG_CUSTOMER_TV030

/*
 * Include the common settings
 */
//#define CONFIG_SYS_SNAPSHOT

//#define CONFIG_SYS_SUPPORT_MULTICORE

#ifdef CONFIG_SYS_SUPPORT_MULTICORE
#define CONFIG_USE_IRQ                          /* support for IRQs */
#endif
#include <configs/rtd285x_common.h>

#define BOARD_NAME_STRING "Board: 40-RT2852-TEB2HG\n"

#if defined(Config_Board_TV030)
  #define BOARD_NAME "TV030_RTD285X"
#endif

/* Boot Revision */
#ifdef Param_boot_rev /* use define in ${PRJ}.inc */
	#define BOOT_REV_STRING		Param_boot_rev
#else
	#define CONFIG_COMPANY_ID	"V8"
	#define CONFIG_BOARD_ID		"R51QT01"
	#define CONFIG_VERSION		"LB1V018"
	#define BOOT_REV_STRING		CONFIG_COMPANY_ID"-"CONFIG_BOARD_ID"-"CONFIG_VERSION
#endif

/* Panel */
#define PANEL_CONFIG_FROM_FACTORY_PANEL_BIN

/*  AMP (need modified board's PIN  */
#define CONFIG_CMD_MISC
#define CONFIG_SYS_I2C_SPEED    100000
/*ALC1310 amp*/
//#define CONFIG_REALTEK_AMP_ACL1310

/*OTP*/
//#define CONFIG_RTK_OTP_AUTO_BURN_ARMTZ_ENABLE

// Note!! This is only when you want to trigger OTP auto program.
// Before enable this, please make sure the otpmap.bin matched your wish.
// Currently, it's about tv006's otp
// #define CONFIG_AUTO_PROGRAM_OTP
#define CONFIG_BOOTUP_BY_PREV_POWER_STATUS
#define CONFIG_MISC_MGR_WAKEUP

#define RTD_LOGBUF_LOGSWI_CUSTOMER      "8000ff40"            // logswi. Transfer parameters customer value
#define CONFIG_VIP_SUPPORT
#ifdef CONFIG_VIP_SUPPORT
#define CONFIG_VIP_RESERVED_ADDR 0x2fe00000
#define CONFIG_VIP_RESERVED_SIZE  0x200000
#else
#define CONFIG_VIP_RESERVED_ADDR 0x0000000
#define CONFIG_VIP_RESERVED_SIZE  0x0000000
#endif
#define CONFIG_OD_SUPPORT
#ifdef CONFIG_OD_SUPPORT
#define CONFIG_OD_RESERVED_ADDR 0x30000000
#define CONFIG_OD_RESERVED_SIZE  0x800000
#else
#define CONFIG_OD_RESERVED_ADDR 0x00000000
#define CONFIG_OD_RESERVED_SIZE  0x0000000
#endif
#endif /* __CONFIG_RTK_DEMO_H */
