/*
 * Configuration settings for the Realtek Demo board.
 *
 * Won't include this file.
 * Just type "make <board_name>_config" and will be included in source tree.
 */

#ifndef __CONFIG_RTK_DEMO_H
#define __CONFIG_RTK_DEMO_H

// This config can be used only when the patch really can't follow customize api.
// So please try to find out the best solution when porting customer features.
// You can also discuss with boot/kernel team members for more suggestion.
#define CONFIG_CUSTOMER_TV035

//#define IS_FPGA_RUN_ON_DISRAM

/*
 * Include the common settings
 */
//#define CONFIG_SYS_SNAPSHOT

//#define CONFIG_SYS_SUPPORT_MULTICORE

#ifdef CONFIG_SYS_SUPPORT_MULTICORE
#define CONFIG_USE_IRQ                          /* support for IRQs */
#endif
#include <configs/rtd285x_common.h>

#define BOARD_NAME_STRING "Board: RTD285X TV035 Board\n"

#if defined(Config_Board_TV035_16x16)
  #define BOARD_NAME "TV035_RTD285X"
#endif
/* Boot Revision */
#ifdef Param_boot_rev /* use define in ${PRJ}.inc */
	#define BOOT_REV_STRING		Param_boot_rev
#else
	#define CONFIG_COMPANY_ID	"0001"
	#define CONFIG_BOARD_ID		"0000"
	#define CONFIG_VERSION		"0000"
	#define BOOT_REV_STRING		CONFIG_COMPANY_ID"."CONFIG_BOARD_ID"."CONFIG_VERSION
#endif

/*  AMP (need modified board's PIN  */
#define CONFIG_CMD_MISC
#define CONFIG_SYS_I2C_SPEED    100000
#if defined (Config_TPV_AMP_TRUE)
#define CONFIG_REALTEK_AMP_BM28723MUV
#else
/*ALC1310 amp*/
//#define CONFIG_REALTEK_AMP_ACL1310
#define CONFIG_REALTEK_AMP_ALC1311
#endif

//#undef ENABLE_DISPI_BISR
//#undef ENABLE_DISPD_BISR
//#undef ENABLE_DISP2TVE_BISR


// Note!! This is only when you want to trigger OTP auto program.
// Before enable this, please make sure the otpmap.bin matched your wish.
// Currently, it's about tv006's otp
// #define CONFIG_AUTO_PROGRAM_OTP

#define RTD_LOGBUF_LOGSWI_CUSTOMER      "8000ff40"            // logswi. Transfer parameters customer value
#define CONFIG_VIP_SUPPORT
#ifdef CONFIG_VIP_SUPPORT
#define CONFIG_VIP_RESERVED_ADDR 0x2fe00000
#define CONFIG_VIP_RESERVED_SIZE  0x200000
#else
#define CONFIG_VIP_RESERVED_ADDR 0x0000000
#define CONFIG_VIP_RESERVED_SIZE  0x0000000
#endif
#define CONFIG_OD_SUPPORT
#ifdef CONFIG_OD_SUPPORT
#define CONFIG_OD_RESERVED_ADDR 0x30000000
#define CONFIG_OD_RESERVED_SIZE  0x800000
#else
#define CONFIG_OD_RESERVED_ADDR 0x00000000
#define CONFIG_OD_RESERVED_SIZE  0x0000000
#endif
#endif /* __CONFIG_RTK_DEMO_H */
