/**
 * @file frdlcdapi.c
 *
 * @brief LCD
 *
 * Copyright (c) 2008 SHARP CORPORATION
 *
 * @author 
 */

/* NOTE : ΥեϡġFRCѥإåեؤ
          WrapperȤƤޤ
          ºݤεҤɲäϡ̤Υإåեɵ
 */


/* **
 * ** include
 * **/
 //@@@@@@@@@@@@@@@@@@@@@@@@
#define TURNKEY1 1
#define printf(...)
#include <common.h>
//@@@@@@@@@@@@@@@@@@@@@@@@

#include <tcon/frdlcdapi.h>

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
#define YELLOWTAIL_VALID
#define FRDLCD_FPGA_VALID
#endif //TURNKEY1


#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
//?#include "frdlcdzyapi.h"	/* ZucchiniYellowTailѥإåե */
//?#include "frdlcdarapi.h"	/* Arugulaѥإåե */
#endif //TURNKEY1

#include <tcon/frdlcdplapi.h>	/* Plaiceѥإåե(TCON¦) */
#include <tcon/frdplapi.h>		/* Plaiceѥإåե(FRC¦) */

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
//?#include "frdfpgaapi.h"		/* FPGA(Begonia)ѥإåե */
#endif //TURNKEY1

#include <tcon/frdguapi.h>		/* Guavaѥإåե(FRC¦) */
#include <tcon/frdlcdguapi.h>	/* Guavaѥإåե(TCON¦) */

/* Lib Functions */
#include <tcon/Internal_RegistrationFunction.h>


//Library Version name													//Global20111227
const volatile uint8 sharp_version[]="libDoubleScan_20130129_VER16";	//Global20121205

/* **
 * ** define
 * **/

/* **
 * ** typedef
 * **/

/* **
 * ** variable
 * **/

/* Хѿ */
dFrdLcdControler_e eFrdLcdControler = FRDLCD_PLAICE;	/* default */

//sakata20111013 static dFrdLcdPnlSize_e eFrdLcdPnlSize = FRDLCD_PNL_32;
//static uint8 aucFrdLcdRevInfo[FRDLCD_REVISION_DATA_MAX];
/* **
 * ** func
 * **/

static dResult_e eLcdGetLsiInfo(dFrdLcdControler_e *peControler);

/*!
********************************************************************************
** @brief	ѥ쥸Ϣ³API (LCD¦)
** @param	iRegNum	: 쥸 (: int32)
** @param	ptDatas	: ߥǡ(: dFrdRegVar_t *)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdRegWs( int32 iRegNum, dFrdRegVar_t * ptDatas )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdRegWriteDatas(FRCLCD_MASTER, iRegNum, (dFrcLcdRegVar_t *)ptDatas);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArRegWs(FRDLCDAR_AB, iRegNum, ptDatas);
			break;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlRegWs(LCDPL_AB, iRegNum, ptDatas);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuRegWs(LCDGU_AB, iRegNum, ptDatas);
			break;
		default:
			return S_FAILURE;
	}
	
	return eResult;
}


/*!
********************************************************************************
** @brief	ѥ쥸Ϣ³ɹAPI (LCD¦)
** @param	iRegNum	: 쥸 (: int32)
** @param	ptDatas	: ɹߥǡ(: dFrdRegVar_t *)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdRegRs( int32 iRegNum, dFrdRegVar_t * ptDatas )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdRegReadDatas(FRCLCD_MASTER, iRegNum, (dFrcLcdRegVar_t *)ptDatas);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArRegRs(FRDLCDAR_AB, iRegNum, ptDatas);
			break;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlRegRs(LCDPL_AB, iRegNum, ptDatas);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuRegRs(LCDGU_AB, iRegNum, ptDatas);
			break;
		default:
			return S_FAILURE;
	}
	
	return eResult;
}


/*!
********************************************************************************
** @brief	ѥ쥸ñAPI (LCD¦)
** @param	usAddr	: ɥ쥹	(: uint16)
** @param	usVal	: 	(: uint16)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdRegW( uint16 usAddr, uint16 usVal )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_SOUSA:
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdRegWriteZ(usAddr, usVal);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArRegW(FRDLCDAR_AB, usAddr, usVal);
			break;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlRegW(LCDPL_AB, usAddr, usVal);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuRegW(LCDGU_AB, usAddr, usVal);
			break;
		default:
			return S_FAILURE;
	}
	
	return eResult;
}


/*!
********************************************************************************
** @brief	ѥ쥸ñɹAPI (LCD¦)
** @param	usAddr	: ɥ쥹	(: uint16)
** @param	pusVal	: ɹ	(: uint16 *)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdRegR( uint16 usAddr, uint16 *pusVal )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_SOUSA:
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdRegReadZ(usAddr, pusVal);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArRegR(FRDLCDAR_AB, usAddr, pusVal);
			brak;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			printf("FRDLCD_PLAICE\r\n");
			eResult |= eFrdLcdPlRegR(LCDPL_AB, usAddr, pusVal);
			break;
		case FRDLCD_GUAVA:
			printf("FRDLCD_GUAVA\r\n");
			eResult |= eFrdLcdGuRegR(LCDGU_AB, usAddr, pusVal);
			break;
		default:
			return S_FAILURE;
	}
	
	return eResult;
}


/*!
********************************************************************************
** @brief	ѥͥ륵API
** @param	ePnlSize	: ѥͥ륵(: dFrdLcdPnlSize_e)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note	ɬ eFrdLcdGetLsiInfo ˸Ƥ֤(ӥͤȤƤϡʳϥɬפʤ)
*******************************************************************************/
dResult_e eFrdLcdSetSize( dFrdLcdPnlSize_e ePnlSize )
{
	dResult_e eResult = S_SUCCESS;
	
	/* For test */
	//vInitI2CFunction(&MApi_SWI2C_WriteBytes, &MApi_SWI2C_ReadBytes);
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_SOUSA:
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
		case FRDLCD_ARUGULA:
#endif //TURNKEY1

		case FRDLCD_GUAVA:
			break;
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetSize( ePnlSize );
			break;
		default:
			return S_FAILURE;
	}
	
//sakata20111013	eFrdLcdPnlSize = ePnlSize;
	
	return eResult;
}


/*!
********************************************************************************
** @brief	ѥͥ륵ǧAPI
** @param	pePnlSize	: ѥͥ륵 (: dFrdLcdPnlSize_e *)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
*******************************************************************************/
dResult_e eFrdLcdGetSize( dFrdLcdPnlSize_e *pePnlSize )
{
	dResult_e eResult = S_SUCCESS;
#if 0
	switch(eFrdLcdControler){
		case FRDLCD_SOUSA:
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
		case FRDLCD_ARUGULA:
		case FRDLCD_GUAVA:
//sakata20111013			*pePnlSize = eFrdLcdPnlSize;
			break;
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlGetSize(pePnlSize);
			break;
		default:
			return S_FAILURE;
	}
#else
//sakata20111013	*pePnlSize = eFrdLcdPnlSize;
#endif	
	return eResult;
}


/*!
********************************************************************************
** @brief	T-conLSIȽAPI
** @retval	FRDLCD_ZUCCHINI or FRDLCD_YELLOWTAIL or FRDLCD_ARUGULA or FRDLCD_PLAICE or FRDLCD_GUAVA
** @par 
**			ǽ˥뤹T-conLSIɥ饤APIǤ
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n;
*******************************************************************************/
dFrdLcdControler_e eFrdLcdGetLsiInfo( void )
{
	dFrdLcdControler_e eControler    = FRDLCD_UNKNOWN;
	dFrdLcdControler_e eControlerTmp = FRDLCD_UNKNOWN;
	uint8 ucSuccessCnt=0;
	uint8 ucI2cErrorCnt=0;
	uint8 ucRegErrorCnt=0;
	flag fEnd = FALSE;


#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
#ifdef FRDLCD_FPGA_VALID
#if 0
	eFrdLcdGetSize( &ePnlSize );
	/* 60ξΤI2Cwaitɲáͤκ tI2CT > 750ms Ȥϡ
	   Ȥʤ PE  I2C졼 ޤ140msΤǡ750-140 = 610ms  */

		if( ePnlSize == FRDLCD_PNL_60 ) MDrv_Timer_Delayms( 610 );

#else
	/* ManagerͿʤθȡwaitΤ
	    Ȥꤢwait 610msȤޤư֤ؤαƶˤĤդɬפ롣2009.07.16 */

		MDrv_Timer_Delayms( 610 );
	
#endif
#endif
#endif //TURNKEY1

	eFrdLcdControler = FRDLCD_GUAVA; /* ǽʤȡöUNKNOWNȽ̤ȰʹǤʤ */
	
	while(1){
		
		if(eLcdGetLsiInfo(&eControler) == S_SUCCESS){
		
			if((eControler == eControlerTmp) && (eControler != FRDLCD_UNKNOWN)){
				ucSuccessCnt++;
				if(ucSuccessCnt == 2){
					fEnd = TRUE;
					break;
				}
			}
			else{
				ucSuccessCnt = 0;
				ucRegErrorCnt++;
				if(ucRegErrorCnt == 4)break;
			}

			MDrv_Timer_Delayms( 5 );

		}
		else{
			ucSuccessCnt = 0;
			ucI2cErrorCnt++;
			if(ucI2cErrorCnt == 10)break;
				MDrv_Timer_Delayms(10);
		}
		eControlerTmp = eControler;
	}
	
	if(fEnd == FALSE){
	/* ǽŪ˼Ԥξ */
		eControler = FRDLCD_UNKNOWN;
	}
	
	eFrdLcdControler = eControler;
	
	return eControler;
}


/*!
********************************************************************************
** @brief	EEPROMｪλåAPI
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdChkEepLoadEnd( void )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_SOUSA:
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdCheckEepLoadEnd();
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArChkRomLoadEnd();
			break;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlChkRomLoadEnd();
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuChkRomLoadEnd();
			break;
		default:
			return S_FAILURE;
	}
#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
#ifdef FRDLCD_FPGA_VALID
	/* 60ΤߡFPGA(Begonia)εưλԤɬ */
	eFrdLcdGetRevInfo( aucFrdLcdRevInfo );
	if( ( aucFrdLcdRevInfo[FRDLCD_REVISION_INCHI] == 0x60 ) && ( eFrdLcdControler != FRDLCD_GUAVA ) ){
		eResult = eFrdFpgaGetStatus();
	}
#endif
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	API(LCD¦)
** @param	fLrDrive	: ѥͥư, TRUE = ¦ư, FALSE = ξ¦ư (: flag)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdInit( flag fLrDrive )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdInitialize((dFrcLcdPanelSystem_e)fLrDrive);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArInit(fLrDrive);
			break;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlInit();	/* ¦Τ */
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuInit();	/* ¦Τ */
			break;
		default:
			return S_FAILURE;
	}
	
	return eResult;
}


/*!
********************************************************************************
** @brief	ȿžAPI
** @param	eTrnOvr : ȿž(: dFrdLcdTrnOvr_e)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetTrnOvr( dFrdLcdTrnOvr_e eTrnOvr )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_SOUSA:
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdSetTurnOver((dFrcLcdTurnOver_e)eTrnOvr);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetTrnOvr(eTrnOvr);
			break;
#endif

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetTrnOvr(eTrnOvr);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetTrnOvr(eTrnOvr);
			break;
		default:
			return S_FAILURE;
	}
	
	return eResult;
}


/*!
********************************************************************************
** @brief	API
** @param	fOutEnable	: (ON/OFF), TRUE = ON, FALSE = OFF (: flag)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**			ArugulaLSIǤϡOFF뤳ȤϤǤޤ
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetOutput( flag fOutEnable )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_SOUSA:
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
			eResult |= eFrcLcdOutputEnable();
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetOutput(fOutEnable);
			break;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetOutput(fOutEnable);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetOutput(fOutEnable);
			break;
		default:
			return S_FAILURE;
	}
	
#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
#ifdef FRDLCD_FPGA_VALID
	if( ( aucFrdLcdRevInfo[FRDLCD_REVISION_INCHI] == 0x60 ) && ( eFrdLcdControler != FRDLCD_GUAVA ) ){
	/* 60ξ */
		eFrdFpgaSetOutput( fOutEnable );
	}
#endif
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	LCDƥȥѥAPI
** @param	eTestPtn : ƥȥѥֹ(: dFrdLcdTestPtn_e)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetTestPtn( dFrdLcdTestPtn_e eTestPtn )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_SOUSA:
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdSetTestPattern((dFrcLcdTestPattern_e)eTestPtn);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetTestPtn(eTestPtn);
			break;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetTestPtn(eTestPtn);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetTestPtn(eTestPtn);
			break;
		default:
			return S_FAILURE;
	}
	
	return eResult;
}


/*!
********************************************************************************
** @brief	LCDѥѥAPI
** @param	ucAgingPtn : 󥰥ѥֹ [0x00-0x21] (: uint8)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**			Zucchini0x1FʹߤΥѥɽޤ
**			Arugula0x20ʹߤΥѥɽޤ
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetAgingPtn( uint8 ucAgingPtn )
{
	dResult_e eResult = S_SUCCESS;
	
	if((eFrdLcdControler == FRDLCD_ZUCCHINI) && (ucAgingPtn >= 0x1F )) return S_FAILURE;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdAgingPattern(ucAgingPtn);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetAgingPtn(ucAgingPtn);
			break;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetAgingPtn(ucAgingPtn);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetAgingPtn(ucAgingPtn);
			break;
		default:
			return S_FAILURE;
	}
	
	return eResult;
}


/*!
********************************************************************************
** @brief	LCDɾѥѥAPI
** @param	ucEvaPtn : ѥֹ [0x00-0x12] (: uint8)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**			Zucchini, ArugulaǤϡ0x12Υѥɽޤ
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetEvaPtn( uint8 ucEvaPtn )
{
	dResult_e eResult = S_SUCCESS;
	
	if((eFrdLcdControler == FRDLCD_ZUCCHINI) && (ucEvaPtn >= 0x12 )) return S_FAILURE;
	
	switch(eFrdLcdControler){


#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdEvaPattern(ucEvaPtn);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetEvaPtn(ucEvaPtn);
			break;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetEvaPtn(ucEvaPtn);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetEvaPtn(ucEvaPtn);
			break;
		default:
			return S_FAILURE;
	}
	
	return eResult;
}


/*!
********************************************************************************
** @brief	QS ON/OFFAPI
** @param	fQsEnable	: QS ON/OFF, TRUE = ON, FALSE = OFF (: flag)
** @param	fYuv 		: Ͽ, TRUE = YUV, FALSE = Y (: flag)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**			YUV/YθɬפΤYellowtailPlaiceǤ¾LSIξ硢
**			fYuvͤŬǹޤ
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetQsEnable( flag fQsEnable, flag fYuv )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_ZUCCHINI:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdSetQsEnable(fQsEnable);
#endif
			break;
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdSetEcoQsEnable(fQsEnable, fYuv);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetQsEnable(fQsEnable);
			break;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetQsEn(fQsEnable, fYuv);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetQsEn(fQsEnable);
			break;
		default:
			return S_FAILURE;
	}
	
	return eResult;
}


/*!
********************************************************************************
** @brief	QSȾON/OFFAPI
** @param	fLonRoff : ȾON/OFF, TRUE = ONOFF, FALSE = OFFON (: flag)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetQsHalf( flag fLonRoff )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdSetQsHalf( fLonRoff );
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetQsHalf( fLonRoff );
			break;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetQsHalf( fLonRoff );
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetQsHalf( fLonRoff );
			break;
		default:
			return S_FAILURE;
	}
	
	return eResult;
}


/*!
********************************************************************************
** @brief	QSȿAPI
** @param	eInputFreq : ϼȿ (: dFrdInputFreq_e)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetQsFreq( dFrdInputFreq_e eInputFreq )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdSetQsFreq((dFrcLcdInputFreq_e)eInputFreq);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetQsFreq(eInputFreq);
			break;
#endif //TURNKEY1


		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetQsFreq(eInputFreq);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetQsFreq(eInputFreq);
			break;
		default:
			return S_FAILURE;
	}
	
	return eResult;
}


/*!
********************************************************************************
** @brief	QSAPI
** @param	ucTemp : ٻ [0(㲹)-7(ⲹ)] (: uint8)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetQsTemp( uint8 ucTemp )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdSetQsTemp(ucTemp);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetQsTemp(ucTemp);
			break;
#endif //TURNKEY1


		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetQsTemp(ucTemp);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetQsLvl(ucTemp);
			break;
		default:
			return S_FAILURE;
	}

	if ( eResult == S_SUCCESS ) {
#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		eDbgPrintf(DBG_LOG, "FRD: QS LEVEL = %d\n", ucTemp);
#endif //TURNKEY1
	}

	return eResult;
}


/*!
********************************************************************************
** @brief	SBRAPI
** @param	ucTemp : ٻ [0(㲹)-7(ⲹ)] (: uint8)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				 [ eFrdSetTemp() 뤿ᥳɬפʤ]\n
**			Guava:				 [ eFrdSetTemp() 뤿ᥳɬפʤ]\n
*******************************************************************************/
dResult_e eFrdLcdSetSbr( uint8 ucTemp )
{
	dResult_e eResult = S_SUCCESS;


#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
#ifdef FRDLCD_FPGA_VALID
	if( aucFrdLcdRevInfo[FRDLCD_REVISION_INCHI] != 0x60 ){
#endif
#endif //TURNKEY1
		switch(eFrdLcdControler){


#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
			case FRDLCD_ZUCCHINI:
			case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
				eResult |= eFrcLcdSetSbr(ucTemp);
#endif
				break;
			case FRDLCD_ARUGULA:
				eResult |= eFrdLcdArSetSbr(ucTemp);
				break;
#endif //TURNKEY1


			case FRDLCD_PLAICE:
				eResult |= eFrdLcdPlSetSbr(ucTemp);
				break;
			case FRDLCD_GUAVA:
				eResult |= eFrdLcdGuSetSbr(ucTemp);
				break;
			default:
				return S_FAILURE;
		}

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
#ifdef FRDLCD_FPGA_VALID
	}
	else{
	/* 60ξ */
		switch(eFrdLcdControler){
			case FRDLCD_ARUGULA:
				eResult |= eFrdFpgaSetTemp( ucTemp );	/* Begoniaˤ */
				break;
			case FRDLCD_PLAICE:
				eResult |= eFrdLcdPlSetSbr(ucTemp);		/* Plaiceˤ */
				break;
			case FRDLCD_GUAVA:
				eResult |= eFrdLcdGuSetSbr(ucTemp);		/* Guavaˤ */
				break;
			default:
				return S_FAILURE;
		}
	}
#endif
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	RevisionAPI
** @param	pucRevInfo : RevisionǡǼΥݥ(: uint8)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdGetRevInfo( uint8 *pucRevInfo )
{
	dResult_e eResult = S_SUCCESS;
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdGetRevInfo(pucRevInfo);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArGetRevInfo(pucRevInfo);
			break;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlGetRevInfo(pucRevInfo);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuGetRevInfo(pucRevInfo);
			break;
		default:
			return S_FAILURE;
	}
	
	return eResult;
}


/*!
********************************************************************************
** @brief	()RevisionAPI
** @param	pucRevInfo : RevisionǡǼΥݥ(: uint8)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdGetUnifiedRevInfo( uint8 *pucRevInfo )
{
	dResult_e eResult = S_SUCCESS;
#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
		case FRDLCD_ARUGULA:
			break;
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlGetUnifiedRevInfo(pucRevInfo);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuGetUnifiedRevInfo(pucRevInfo);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	ROM Revision ɽAPI
** @param	pcRevInfo : RevisionǡɽʸǼΥݥ(: int8)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par  Υɬ32ХȤݤ뤳ȡ
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdGetRevStr( int8 *pcRevInfo )
{
	dResult_e eResult = S_SUCCESS;
	
#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
#ifdef FRDLCD_FPGA_VALID
	int32	i;
#endif
#endif //TURNKEY1
	
	switch(eFrdLcdControler){

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
			eResult = S_FAILURE;
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArGetRevStr(pcRevInfo);
			break;
#endif //TURNKEY1

		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlGetRevStr(pcRevInfo);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuGetRevStr(pcRevInfo);
			break;
		default:
			return S_FAILURE;
	}

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
#ifdef FRDLCD_FPGA_VALID
	if( ( aucFrdLcdRevInfo[FRDLCD_REVISION_INCHI] == 0x60 ) && ( eFrdLcdControler != FRDLCD_GUAVA ) )
	{
		for(i=0; i<32; i++)
		{
			if( *(pcRevInfo + i) == '\0' )
			{
				*(pcRevInfo + i) = '/';
				eFrdFpgaGetFlashVerStr( (pcRevInfo + i + 1) );
				break;
			}
		}
	}
#endif
#endif //TURNKEY1

	return eResult;
}


/*!
********************************************************************************
** @brief	ROMǡϢ³API
** @param	uiAddr		: ROM襢ɥ쥹			(: uint32)
** @param	uiLength	: ߥǡĹ				(: uint32)
** @param	pucDatas	: ߥǡƬݥ	(: uint8*)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				 [ eFrdLcdSetVerUp() 뤿ᥳɬפʤ]\n
**			Guava:				 [ eFrdLcdSetVerUp() 뤿ᥳɬפʤ]\n
*******************************************************************************/
dResult_e eFrdLcdEepWs( uint32 uiAddr, uint32 uiLength, uint8* pucDatas )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdWriteEepDatas(FRCLCD_MASTER, uiAddr, uiLength, pucDatas);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArRomWs(uiAddr, uiLength, pucDatas);
			break;
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlRomWs(uiAddr, uiLength, pucDatas);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuRomWs(uiAddr, uiLength, pucDatas);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	ROMǡϢ³ɹAPI
** @param	uiAddr		: ROMɹ襢ɥ쥹			(: uint32)
** @param	uiLength	: ɹߥǡĹ				(: uint32)
** @param	pucDatas	: ɹߥǡƬݥ	(: uint8*)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				 [ eFrdLcdSetVerUp() 뤿ᥳɬפʤ]\n
**			Guava:				 [ eFrdLcdSetVerUp() 뤿ᥳɬפʤ]\n
*******************************************************************************/
dResult_e eFrdLcdEepRs( uint32 uiAddr, uint32 uiLength, uint8* pucDatas )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1	
	switch(eFrdLcdControler){
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdReadEepDatas(uiAddr, (uint16)uiLength, pucDatas);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArRomRs(uiAddr, (uint16)uiLength, pucDatas);
			break;
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlRomRs(uiAddr, (uint16)uiLength, pucDatas);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuRomRs(uiAddr, (uint16)uiLength, pucDatas);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	ROMǡõAPI
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				 [ eFrdLcdSetVerUp() 뤿ᥳɬפʤ]\n
**			Guava:				 [ eFrdLcdSetVerUp() 뤿ᥳɬפʤ]\n
*******************************************************************************/
dResult_e eFrdLcdEepErase( void )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdSerialFlashBulkErase();
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArRomBulkErase();
			break;
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlRomErase();
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuRomErase();
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	ľǥ ON/OFFAPI
** @param	eDecontEnable	: ǥ ON/OFF (: dFrdLcdDecont_e)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note    ArugulaΤ
*******************************************************************************/
dResult_e eFrdLcdSetDecontEnable( dFrdLcdDecont_e eDecontEnable )
{
	dResult_e	eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetDecontEnable(eDecontEnable);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	ROMС󥢥åAPI
** @param	pucDats	: ROMǡƬݥ (: uint8 *)
** @param	fVerify	: ٥ե, TRUE = ON, FALSE = OFF (: flag)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetVerUp( uint8 *pucDats, flag fVerify )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetVerUp(pucDats,fVerify);
			break;
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetVerUp(pucDats,fVerify);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetVerUp(pucDats,fVerify);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	̽API
** @param	ePnlSize	: ѥͥ륵(: dFrdLcdPnlSize_e)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**			VerUpβФδؿǤ\n
**			бѥͥ륵Υǡɤޤ\n
**			APIǡAPI뤵Ƥޤ
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdOutSource( dFrdLcdPnlSize_e ePnlSize )
{
	dResult_e eResult = S_SUCCESS;
	
#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	uint8 aucTmp[16];
	flag fLrDrive = TRUE;
	
	eFrdLcdGetLsiInfo();
	eResult |= eFrdLcdSetSize(ePnlSize);
	eResult |= eFrdLcdChkEepLoadEnd();
	eResult |= eFrdLcdGetRevInfo(aucTmp);
	if(aucTmp[FRDLCD_REVISION_PANEL]) fLrDrive = FALSE;
	eResult |= eFrdLcdInit(fLrDrive);
	eResult |= eFrdInit(fLrDrive, FRD_INPUT_FREQ_60HZ);
	eResult |= eFrdLcdSetTrnOvr(FRDLCD_TRN_OVR_NORMAL);
	eResult |= eFrdLcdSetOutput(TRUE);
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	ե꡼API (LCD¦)
** @param	fFreeRunEnable	: ե꡼, TRUE = ON, FALSE = OFF (: flag)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetFreeRun( flag fFreeRunEnable )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdSetFreeRun(fFreeRunEnable);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetFreeRun(fFreeRunEnable);
			break;
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetFreeRun(fFreeRunEnable);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetFreeRun(fFreeRunEnable);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	ϲǥǡ(RGB)API
** @param	x			: Xɸ		(: uint16)
** @param	y			: Yɸ		(: uint16)
** @param	ptRgbColor	: RGB		(: dFrdLcdRgb_t)
** @retval	S_SUCCESS 
** @retval	S_FAILURE 
** @par		: PPDSʤˤǥǡޤ
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			\n
**			Plaice:				̤\n
**			Guava:				̤\n
********************************************************************************/
dResult_e eFrdLcdGetRgb(uint16 x, uint16 y, dFrdLcdRgb_t *ptRgbColor)
{
	dResult_e	eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArGetRgb(x, y, ptRgbColor);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	ƥȥѥ(٥ɽ)Ѵؿ
** @param	ptColor :  (: dFrdLcdTpColor_t)
** @retval	S_SUCCESS 
** @retval	S_FAILURE 
** @par		: 
**			LCDC¦ɾѥƥȥѥ"0x03 : ٥ɽ"Ǥ\n
**			ptColor = NULL Ȥƥ뤹̾⡼ɤޤ\n
**			岼ٺĴ˻Ѥ뤳ȤꤷΤǤ\n
**			λNULLȤƥ뤷Ƥ
** @note    
**			Fraser+Zucchini:	\n
**			Yellowtail:			̤\n
**			Arugula:			\n
**			Plaice:				̤\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdSetBetaPtn( dFrdLcdTpColor_t *ptColor )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		case FRDLCD_ZUCCHINI:
		case FRDLCD_YELLOWTAIL:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdSetTestPatternBeta((dFrcLcdTestPaternColor_t *)ptColor);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetBetaPtn(ptColor);
			break;
#endif //TURNKEY1
		case FRDLCD_PLAICE:
		case FRDLCD_GUAVA:
			/* ⤷ޤ */
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	ѥͥ岼ٺĴAPI(¦)
** @param	iLevel : Ĵ (: int32)
** @retval	S_SUCCESS 
** @retval	S_FAILURE 
** @par		: Ĵ(¦)DAC쥸ĴˤԤޤ
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			̤\n
**			Arugula:			\n
**			Plaice:				̤\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdSetLumaAdjU( int32 iLevel )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_ZUCCHINI:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdSetLumaAdjU(iLevel);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArSetLumaAdjU(iLevel);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	ѥͥ岼ٺĴͼAPI(¦)
** @param	piLevel : Ĵ (: int32)
** @retval	S_SUCCESS 
** @retval	S_FAILURE 
** @par		: Ĵ(¦)֤ޤ
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			̤\n
**			Arugula:			\n
**			Plaice:				̤\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdGetLumaAdjU( int32 *piLevel )
{
	dResult_e eResult = S_SUCCESS;
	
#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_ZUCCHINI:
#ifdef YELLOWTAIL_VALID
			eResult |= eFrcLcdGetLumaAdjU(piLevel);
#endif
			break;
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArGetLumaAdjU(piLevel);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	顼API
** @param	ptError : Ĵ (: dFrdLcdError_t)
** @retval	S_SUCCESS 
** @retval	S_FAILURE 
** @par		: 
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
********************************************************************************/
dResult_e eFrdLcdGetErrInfo( dFrdLcdError_t *ptError )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	if( ptError == NULL ) return S_FAILURE;

	ptError->ucErrCode = 0;/*  */
	
	switch(eFrdLcdControler){
		case FRDLCD_ARUGULA:
			eResult |= eFrdLcdArGetErrInfo(ptError);
			break;
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlGetErrInfo(ptError);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuGetErrInfo(ptError);
			break;
		default:
			break;
	}
#ifdef FRDLCD_FPGA_VALID
	if( ( aucFrdLcdRevInfo[FRDLCD_REVISION_INCHI] == 0x60 ) && ( eFrdLcdControler != FRDLCD_GUAVA ) ){
		if( ptError->ucErrCode == 0 ){
			eResult |= eFrdFpgaGetErrInfo(ptError);
		}
	}
#endif
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	ޥ˥奢ѥ¹API
** @retval	S_SUCCESS 
** @retval	S_FAILURE 
** @par		: 
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			\n
**			Plaice:				\n
**			Guava:				\n
********************************************************************************/
dResult_e eFrdLcdAllManualLoad( void )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_ARUGULA:
			eResult |= eFrdArAllManualLoad();	/* FRC¦ */
			eResult |= eFrdLcdArAllManualLoad();/* LCDC¦ */
			break;
		case FRDLCD_PLAICE:
			eResult |= eFrdPlAllManualLoad();	/* FRC¦ */
			eResult |= eFrdLcdPlAllManualLoad();/* LCDC¦ */
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdGuAllManualLoad();	/* FRC¦ */
			eResult |= eFrdLcdGuAllManualLoad();/* LCDC¦ */
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	LCD󥰥ѥAPI (FR¦)
** @param	ucFrAgingPtn : 󥰥ѥֹ [0x00-0x21] (: uint8)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdSetFrAgingPtn( uint8 ucFrAgingPtn )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetFrAgingPtn(ucFrAgingPtn);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	LCDɾѥѥAPI (FR¦)
** @param	ucFrEvaPtn : ɾѥѥֹ [0x00-0x12] (: uint8)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdSetFrEvaPtn( uint8 ucFrEvaPtn )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetFrEvaPtn(ucFrEvaPtn);
			break;
		default:
			return S_FAILURE;
	}

#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	Unveil ON/OFFAPI
** @param	fUvlEn : Unveil ON/OFF (: flag)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdSetUvlEn( flag fUvlEn )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetUvlEn(fUvlEn);
			break;
		default:
			return S_FAILURE;
	}

#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	Unveil API
** @param	ucUvlMode : Unveil  [0x0()-0xF()] (: uint8)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**			ƶ٤˱ϢưΥѥ᡼MNLޤ
**
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdSetUvlMode( uint8 ucUvlMode )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetUvlMode(ucUvlMode);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	 ON/OFFAPI
** @param	fBdEn :  ON/OFF (: flag)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**			졼˸Yellow band㸺Ǥ
**
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetBdEn( flag fBdEn )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetBdEn(fBdEn);
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetBdEn(fBdEn);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	Υ ⡼API
** @param	eNrMode : Υ ON/OFF (: dFrdLcdNrMode_e)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**			åȤʤɡΰΥΥʿ경ޤ
**			ʤɤΥǥƥӤǤϻѤʤǤ
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdSetNrMode( dFrdLcdNrMode_e eNrMode )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetNrMode(eNrMode);
			break;
		default:
			return S_FAILURE;
	}

#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	Υ ޥAPI
** @param	ucMaskNo	: ޥֹ [1-4] (: uint8)
** @param	fMaskEn	: ޥ, TRUE = ON, FALSE = OFF (: flag)
** @param	ptMaskFrame	: ΰ (: dFrdFrame *)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdSetNrMask( uint8 ucMaskNo, flag fMaskEn, dFrdFrame_t *ptMaskFrame )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetNrMask(ucMaskNo, fMaskEn, ptMaskFrame );
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	PCC ON/OFFAPI
** @param	fPccEn : PCC ON/OFF (: flag)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdSetPccEn( flag fPccEn )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1	
	switch(eFrdLcdControler){
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetPccEn(fPccEn);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	PCC ΰON/OFFAPI
** @param	ucColNo		: ΰֹ [1-6] (: uint8)
** @param	fColEn		: ΰON/OFF (: flag)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**			ΰε,,ON/OFFޤ
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdSetPccColEn( uint8 ucColNo, flag fColEn )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetPccColEn(ucColNo, fColEn);
			break;
		default:
			return S_FAILURE;
	}

#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	ΰε,, ON/OFFAPI
** @param	ucColNo		: ΰֹ [1-6] (: uint8)
** @param	fBriEn		: ΰεON/OFF (: flag)
** @param	fSatEn		: ΰκON/OFF (: flag)
** @param	fHueEn		: ΰοON/OFF (: flag)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdSetPccBshEn( uint8 ucColNo, flag fBriEn, flag fSatEn, flag fHueEn )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetPccBshEn(ucColNo, fBriEn, fSatEn, fHueEn);
			break;
		default:
			return S_FAILURE;
	}

#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	 ΰ, °ΰAPI
** @param	ucColNo		: ΰֹ [1-6] (: uint8)
** @param	eBsh		: ΰ (: dFrdLcdBsh_e)
** @param	usCenter	: ΰ濴			[0x0000-0xFFFF] (: uint16)
** @param	usDelta		: 濴ΰüޤǤεΥ	[0x0000-0xFFFF] (: uint16)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**			˻ΰONƤ
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdSetPccBshArea( uint8 ucColNo, dFrdLcdBsh_e eBsh, uint16 usCenter, uint16 usDelta )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetPccBshArea(ucColNo, eBsh, usCenter, usDelta);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	 ΰ, °Υ٥API
** @param	ucColNo		: ΰֹ [1-6] (: uint8)
** @param	eBsh		: ΰ (: dFrdLcdBsh_e)
** @param	usLvl		: Ĵ٥ (: uint16), 
**						,:	[0x400(0)0x000(1)0x3FF(2)], 
**						:		[0x400(-180)0x000(0)0x3FF(180)]
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**			˻ΰONƤ
** @note
**			Fraser+Zucchini:	̤\n
**			Yellowtail:			̤\n
**			Arugula:			̤\n
**			Plaice:				\n
**			Guava:				̤\n
*******************************************************************************/
dResult_e eFrdLcdSetPccBshLvl( uint8 ucColNo, dFrdLcdBsh_e eBsh, uint16 usLvl )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlSetPccBshLvl(ucColNo, eBsh, usLvl);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	Gamma LUT 񤭴API (Plaiceк 2009.06.29)
** @param	fChgEn		: 񴹤ON/OFF (: falg)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
*******************************************************************************/
dResult_e eFrdLcdChgGamLut( flag fChgEn )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_ARUGULA:
			break;
		case FRDLCD_PLAICE:
			eResult |= eFrdLcdPlChgGamLut(fChgEn);
			break;
		default:
			return S_FAILURE;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	DACAPI (VCOM)
** @param	fMemEn :  TRUE: ꡼, FALSE: 쥸 (: flag)
** @param	usDat  : VCOMĴǡ (: uint16)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**
** @note
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetDac( flag fMemEn, uint16 usDat )
{
	dResult_e eResult = S_SUCCESS;

//#ifdef TURNKEY1		//SERD zhang 2012/10/15 delete
//TURNKEY1 nothing
//#else //TURNKEY1		//SERD zhang 2012/10/15 delete
	switch(eFrdLcdControler){
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetDac(fMemEn, usDat);
			break;
		default:
			return S_FAILURE;
	}
//#endif //TURNKEY1		//SERD zhang 2012/10/15 delete
	return eResult;
}


/*!
********************************************************************************
** @brief	DACǧAPI (VCOM)
** @param	fMemEn :  TRUE: ꡼, FALSE: 쥸 (: flag)
** @param	pusDat  : VCOMĴǡ (: uint16 *)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**
** @note
**			Guava:				(˥꤫꡼)\n
*******************************************************************************/
dResult_e eFrdLcdGetDac( flag fMemEn, uint16 *pusDat )
{
	dResult_e eResult = S_SUCCESS;

//#ifdef TURNKEY1		//SERD zhang 2012/10/15 delete
//TURNKEY1 nothing
//#else //TURNKEY1		//SERD zhang 2012/10/15 delete
	switch(eFrdLcdControler){
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuGetDac(pusDat);
			break;
		default:
			return S_FAILURE;
	}
//#endif //TURNKEY1		//SERD zhang 2012/10/15 delete
	return eResult;
}


/*!
********************************************************************************
** @brief	٥٥API
** @param	ucLvl	: ٥٥λ [0(㲹)-7(ⲹ)] (: uint8 *)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
**
** @note
**			Guava:				\n
*******************************************************************************/
dResult_e eFrdLcdSetLvl( uint8 ucLvl )
{
	dResult_e eResult = S_SUCCESS;

	switch(eFrdLcdControler){
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetLvl(ucLvl);
			break;
		default:
			break;
	}
	return eResult;
}


/*!
********************************************************************************
** @brief	ߥ塼API
** @param	fMuteEnable	: ߥ塼, TRUE = ON, FALSE = OFF (: flag)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
**			Fraser+Zucchini:	\n
**			Yellowtail:			\n
**			Arugula:			\n
**			Plaice:				\n
*******************************************************************************/
dResult_e eFrdLcdSetMute( flag fMuteEnable )
{
	dResult_e eResult = S_SUCCESS;

#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
	switch(eFrdLcdControler){
		case FRDLCD_ARUGULA:
			if( fMuteEnable == TRUE ){
				eResult |= eFrdLcdArSetOutput(FALSE);
			}
			else{
				eResult |= eFrdLcdArSetOutput(TRUE);
			}
#ifdef FRDLCD_FPGA_VALID
			if( aucFrdLcdRevInfo[FRDLCD_REVISION_INCHI] == 0x60 ){
				eFrdFpgaSetMute( fMuteEnable );
			}
#endif
			break;
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetOutput(!fMuteEnable);
			break;
		default:
			break;
	}
#endif //TURNKEY1
	return eResult;
}


/*!
********************************************************************************
** @brief	VCOMѥѥɽAPI
** @param	fVcom : VCOMɽ ON/OFF(: flag)
** @retval	S_SUCCESS ｪλ
** @retval	other 顼
** @par 
** @note
*******************************************************************************/
dResult_e eFrdLcdSetVcomPtn( flag fVcomEn )
{
	dResult_e eResult = S_SUCCESS;

//#ifdef TURNKEY1		//SERD zhang 2012/10/15 delete
//TURNKEY1 nothing
//#else //TURNKEY1		//SERD zhang 2012/10/15 delete
	switch(eFrdLcdControler){
		case FRDLCD_GUAVA:
			eResult |= eFrdLcdGuSetVcomPtn(fVcomEn);
			break;
		default:
			break;
	}
//#endif //TURNKEY1		//SERD zhang 2012/10/15 delete
	return eResult;
}


#define FRDLCD_ADDR_ON_BOARD_LSI_HANBETSU	0x6C3D /* SousaII/ZucchiniȽѥ쥸ɥ쥹 */
#define FRDLCD_ADDR_ON_BOARD_LSI_DETECT		0x6CEF /* ȥLSIȽѥ쥸(YellowTailʹ)ɥ쥹 */
static dResult_e eLcdGetLsiInfo(dFrdLcdControler_e *peControler)
{
	printf("In eLcdGetLsiInfo\r\n");
	uint16		usVal;
	dResult_e	eResult = S_SUCCESS;
	
	eResult = eFrdLcdRegR(FRDLCD_ADDR_ON_BOARD_LSI_DETECT, &usVal);/* ArugulaѤɤ߹API */
	printf("In eLcdGetLsiInfo, eResult=%x\r\n",eResult);
	if(eResult != S_SUCCESS){
		printf("In eLcdGetLsiInfo, eResult != S_SUCCESS\r\n");
#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
		eDbgPrintf(0, "[LCDC] FAILURE(eFrdLcdGetLsiInfo)!!!!!\n");
#endif //TURNKEY1
		*peControler = FRDLCD_UNKNOWN;
	}
	else{
		switch(usVal){
			case 0x01:	/* Sousa2 or Zucchini */
				eResult = eFrdLcdRegR(FRDLCD_ADDR_ON_BOARD_LSI_HANBETSU, &usVal);/* ArugulaѤɤ߹API */
				if(eResult != S_SUCCESS){
#ifdef TURNKEY1
//TURNKEY1 nothing
#else //TURNKEY1
					eDbgPrintf(0, "[LCDC] FAILURE(eFrdLcdGetLsiInfo)!!!!!\n");
#endif //TURNKEY1
					*peControler = FRDLCD_UNKNOWN;
				}
				else{
					if((usVal & 0xF0) == 0xF0){
						*peControler = FRDLCD_SOUSA;
					}
					else if((usVal & 0xF0) == 0x00){
						*peControler = FRDLCD_ZUCCHINI;
					}
					else{
						*peControler = FRDLCD_UNKNOWN;
					}
				}
				break;
			case 0x02:	/* YellowTail */
				*peControler = FRDLCD_YELLOWTAIL;	break;
			case 0x03:	/* Zucchini_P */
				*peControler = FRDLCD_ZUCCHINI_P;	break;
			case 0x04:	/* Arugula */
				*peControler = FRDLCD_ARUGULA;		break;
			case 0x05:	/* Plaice */
				*peControler = FRDLCD_PLAICE;		break;
			case 0x07:	/* Guava */
			case 0x08:	/* Turnip */							//sakata20111220
				*peControler = FRDLCD_GUAVA;		break;
			default:
				*peControler = FRDLCD_UNKNOWN;		break;
		}
	}
	return eResult;
}


/*!
********************************************************************************	//Global20120507
** @brief	饤֥С֤API											//Global20120507
** @param	dFrdLcd2Lsi_e	СǼݥ(: uint8*)			//Global20120507
** @retval	S_SUCCESS ｪλ														//Global20120507
** @retval	other 顼														//Global20120507
** @par 																	//Global20120507
** @note																			//Global20120507
*******************************************************************************/	//Global20120507
dResult_e eFrdLcdGetLibVer( uint8* pucLibVer )										//Global20120507>>>>>>>>>>>
{
	dResult_e eResult = S_SUCCESS;
	int version_size = sizeof(sharp_version);
	int version_i;

	for( version_i=0; version_i<version_size; version_i++)
	{
		pucLibVer[version_i] = sharp_version[version_i];
	}
#ifdef SH_DEBUG
	printf("eFrdLcdGetLibVer = %s\n", pucLibVer );
#endif //SH_DEBUG

	return eResult;
}																					//Global20120507<<<<<<<<<<<


/* end of file */
