#ifndef __RTK_I2C_REG_H__
#define __RTK_I2C_REG_H__

#define RTK_I2C_CNT               6


#define I2C0_GPIO_MODE_CTRL                 (0xB8062500)
#define I2C0_GUARD_INTERVAL_CTRL            (0xB8062504)
#define I2C0_GUARD_INTERVAL_STATUS          (0xB8062508)
#define I2C0_SDA_OUTPUT_DELAY_CTRL          (0xB806250C)

#define IC0_ADDRESS_BASE                    (0xB8062600)
#define RTD287o_ISO_IC0_CON                 IC0_ADDRESS_BASE
#define RTD287o_ISO_IC0_TAR                 (IC0_ADDRESS_BASE + 0x4)
#define RTD287o_ISO_IC0_SAR                 (IC0_ADDRESS_BASE + 0x8)
#define RTD287o_ISO_IC0_HS_MADDR            (IC0_ADDRESS_BASE + 0xC)
#define RTD287o_ISO_IC0_DATA_CMD            (IC0_ADDRESS_BASE + 0x10)
#define RTD287o_ISO_IC0_SS_SCL_HCNT         (IC0_ADDRESS_BASE + 0x14)
#define RTD287o_ISO_IC0_SS_SCL_LCNT         (IC0_ADDRESS_BASE + 0x18)
#define RTD287o_ISO_IC0_FS_SCL_HCNT         (IC0_ADDRESS_BASE + 0x1C)
#define RTD287o_ISO_IC0_FS_SCL_LCNT         (IC0_ADDRESS_BASE + 0x20)
#define RTD287o_ISO_IC0_INTR_STAT           (IC0_ADDRESS_BASE + 0x2C) 
#define RTD287o_ISO_IC0_INTR_MASK           (IC0_ADDRESS_BASE + 0x30)   
#define RTD287o_ISO_IC0_RAW_INTR_STAT       (IC0_ADDRESS_BASE + 0x34)  
#define RTD287o_ISO_IC0_RX_TL               (IC0_ADDRESS_BASE + 0x38) 
#define RTD287o_ISO_IC0_TX_TL               (IC0_ADDRESS_BASE + 0x3C)
#define RTD287o_ISO_IC0_CLR_INTR            (IC0_ADDRESS_BASE + 0x40)
#define RTD287o_ISO_IC0_CLR_RX_UNDER        (IC0_ADDRESS_BASE + 0x44)
#define RTD287o_ISO_IC0_CLR_RX_OVER         (IC0_ADDRESS_BASE + 0x48)
#define RTD287o_ISO_IC0_CLR_TX_OVER         (IC0_ADDRESS_BASE + 0x4C)
#define RTD287o_ISO_IC0_CLR_RD_REQ          (IC0_ADDRESS_BASE + 0x50)
#define RTD287o_ISO_IC0_CLR_TX_ABRT         (IC0_ADDRESS_BASE + 0x54)
#define RTD287o_ISO_IC0_CLR_RX_DONE         (IC0_ADDRESS_BASE + 0x58)
#define RTD287o_ISO_IC0_CLR_ACTIVITY        (IC0_ADDRESS_BASE + 0x5C)
#define RTD287o_ISO_IC0_CLR_STOP_DET        (IC0_ADDRESS_BASE + 0x60)
#define RTD287o_ISO_IC0_CLR_START_DET       (IC0_ADDRESS_BASE + 0x64)
#define RTD287o_ISO_IC0_CLR_GEN_CALL        (IC0_ADDRESS_BASE + 0x68)
#define RTD287o_ISO_IC0_ENABLE              (IC0_ADDRESS_BASE + 0x6C)
#define RTD287o_ISO_IC0_STATUS              (IC0_ADDRESS_BASE + 0x70)
#define RTD287o_ISO_IC0_TXFLR               (IC0_ADDRESS_BASE + 0x74)
#define RTD287o_ISO_IC0_RXFLR               (IC0_ADDRESS_BASE + 0x78)
#define RTD287o_ISO_IC0_SDA_HOLD            (IC0_ADDRESS_BASE + 0x7C)
#define RTD287o_ISO_IC0_TX_ABRT_SOURCE      (IC0_ADDRESS_BASE + 0x80)
#define RTD287o_ISO_IC0_SLV_DATA_NACK_ONLY  (IC0_ADDRESS_BASE + 0x84)
#define RTD287o_ISO_IC0_SDA_SETUP           (IC0_ADDRESS_BASE + 0x94)
#define RTD287o_ISO_IC0_ACK_GEN_CALL        (IC0_ADDRESS_BASE + 0x98)
#define RTD287o_ISO_IC0_ENABLE_STATUS       (IC0_ADDRESS_BASE + 0x9C)
#define RTD287o_ISO_IC0_COMP_PARAM_1        (IC0_ADDRESS_BASE + 0xF4)
#define RTD287o_ISO_IC0_COMP_VERSION        (IC0_ADDRESS_BASE + 0xF8)
#define RTD287o_ISO_IC0_COMP_TYPE           (IC0_ADDRESS_BASE + 0xFC)



/*-------------------------------------------------------------
 * RTD287o MISC I2C register
 *-------------------------------------------------------------*/


#define I2C1_GPIO_MODE_CTRL                 0xB801B200
#define I2C1_GUARD_INTERVAL_CTRL            0xB801B204
#define I2C1_GUARD_INTERVAL_STATUS          0xB801B208
#define I2C1_SDA_OUTPUT_DELAY_CTRL          0xB801B20C


#define IC1_ADDRESS_BASE                    0xB801B300
#define RTD287o_MISC_IC1_CON                 (IC1_ADDRESS_BASE)
#define RTD287o_MISC_IC1_TAR                 (IC1_ADDRESS_BASE + 0x4)
#define RTD287o_MISC_IC1_SAR                 (IC1_ADDRESS_BASE + 0x8)
#define RTD287o_MISC_IC1_HS_MADDR            (IC1_ADDRESS_BASE + 0xC)
#define RTD287o_MISC_IC1_DATA_CMD            (IC1_ADDRESS_BASE + 0x10)
#define RTD287o_MISC_IC1_SS_SCL_HCNT         (IC1_ADDRESS_BASE + 0x14)
#define RTD287o_MISC_IC1_SS_SCL_LCNT         (IC1_ADDRESS_BASE + 0x18)
#define RTD287o_MISC_IC1_FS_SCL_HCNT         (IC1_ADDRESS_BASE + 0x1C)
#define RTD287o_MISC_IC1_FS_SCL_LCNT         (IC1_ADDRESS_BASE + 0x20)
#define RTD287o_MISC_IC1_INTR_STAT           (IC1_ADDRESS_BASE + 0x2C) 
#define RTD287o_MISC_IC1_INTR_MASK           (IC1_ADDRESS_BASE + 0x30)   
#define RTD287o_MISC_IC1_RAW_INTR_STAT       (IC1_ADDRESS_BASE + 0x34)  
#define RTD287o_MISC_IC1_RX_TL               (IC1_ADDRESS_BASE + 0x38) 
#define RTD287o_MISC_IC1_TX_TL               (IC1_ADDRESS_BASE + 0x3C)
#define RTD287o_MISC_IC1_CLR_INTR            (IC1_ADDRESS_BASE + 0x40)
#define RTD287o_MISC_IC1_CLR_RX_UNDER        (IC1_ADDRESS_BASE + 0x44)
#define RTD287o_MISC_IC1_CLR_RX_OVER         (IC1_ADDRESS_BASE + 0x48)
#define RTD287o_MISC_IC1_CLR_TX_OVER         (IC1_ADDRESS_BASE + 0x4C)
#define RTD287o_MISC_IC1_CLR_RD_REQ          (IC1_ADDRESS_BASE + 0x50)
#define RTD287o_MISC_IC1_CLR_TX_ABRT         (IC1_ADDRESS_BASE + 0x54)
#define RTD287o_MISC_IC1_CLR_RX_DONE         (IC1_ADDRESS_BASE + 0x58)
#define RTD287o_MISC_IC1_CLR_ACTIVITY        (IC1_ADDRESS_BASE + 0x5C)
#define RTD287o_MISC_IC1_CLR_STOP_DET        (IC1_ADDRESS_BASE + 0x60)
#define RTD287o_MISC_IC1_CLR_START_DET       (IC1_ADDRESS_BASE + 0x64)
#define RTD287o_MISC_IC1_CLR_GEN_CALL        (IC1_ADDRESS_BASE + 0x68)
#define RTD287o_MISC_IC1_ENABLE              (IC1_ADDRESS_BASE + 0x6C)
#define RTD287o_MISC_IC1_STATUS              (IC1_ADDRESS_BASE + 0x70)
#define RTD287o_MISC_IC1_TXFLR               (IC1_ADDRESS_BASE + 0x74)
#define RTD287o_MISC_IC1_RXFLR               (IC1_ADDRESS_BASE + 0x78)
#define RTD287o_MISC_IC1_SDA_HOLD            (IC1_ADDRESS_BASE + 0x7C)
#define RTD287o_MISC_IC1_TX_ABRT_SOURCE      (IC1_ADDRESS_BASE + 0x80)
#define RTD287o_MISC_IC1_SLV_DATA_NACK_ONLY  (IC1_ADDRESS_BASE + 0x84)
#define RTD287o_MISC_IC1_SDA_SETUP           (IC1_ADDRESS_BASE + 0x94)
#define RTD287o_MISC_IC1_ACK_GEN_CALL        (IC1_ADDRESS_BASE + 0x98)
#define RTD287o_MISC_IC1_ENABLE_STATUS       (IC1_ADDRESS_BASE + 0x9C)
#define RTD287o_MISC_IC1_COMP_PARAM_1        (IC1_ADDRESS_BASE + 0xF4)
#define RTD287o_MISC_IC1_COMP_VERSION        (IC1_ADDRESS_BASE + 0xF8)
#define RTD287o_MISC_IC1_COMP_TYPE           (IC1_ADDRESS_BASE + 0xFC)


#define I2C2_GPIO_MODE_CTRL                 0xB801B400
#define I2C2_GUARD_INTERVAL_CTRL            0xB801B404
#define I2C2_GUARD_INTERVAL_STATUS          0xB801B408
#define I2C2_SDA_OUTPUT_DELAY_CTRL          0xB801B40C


#define IC2_ADDRESS_BASE                    0xB801B500
#define RTD287o_MISC_IC2_CON                 (IC2_ADDRESS_BASE)
#define RTD287o_MISC_IC2_TAR                 (IC2_ADDRESS_BASE + 0x4)
#define RTD287o_MISC_IC2_SAR                 (IC2_ADDRESS_BASE + 0x8)
#define RTD287o_MISC_IC2_HS_MADDR            (IC2_ADDRESS_BASE + 0xC)
#define RTD287o_MISC_IC2_DATA_CMD            (IC2_ADDRESS_BASE + 0x10)
#define RTD287o_MISC_IC2_SS_SCL_HCNT         (IC2_ADDRESS_BASE + 0x14)
#define RTD287o_MISC_IC2_SS_SCL_LCNT         (IC2_ADDRESS_BASE + 0x18)
#define RTD287o_MISC_IC2_FS_SCL_HCNT         (IC2_ADDRESS_BASE + 0x1C)
#define RTD287o_MISC_IC2_FS_SCL_LCNT         (IC2_ADDRESS_BASE + 0x20)
#define RTD287o_MISC_IC2_INTR_STAT           (IC2_ADDRESS_BASE + 0x2C) 
#define RTD287o_MISC_IC2_INTR_MASK           (IC2_ADDRESS_BASE + 0x30)   
#define RTD287o_MISC_IC2_RAW_INTR_STAT       (IC2_ADDRESS_BASE + 0x34)  
#define RTD287o_MISC_IC2_RX_TL               (IC2_ADDRESS_BASE + 0x38) 
#define RTD287o_MISC_IC2_TX_TL               (IC2_ADDRESS_BASE + 0x3C)
#define RTD287o_MISC_IC2_CLR_INTR            (IC2_ADDRESS_BASE + 0x40)
#define RTD287o_MISC_IC2_CLR_RX_UNDER        (IC2_ADDRESS_BASE + 0x44)
#define RTD287o_MISC_IC2_CLR_RX_OVER         (IC2_ADDRESS_BASE + 0x48)
#define RTD287o_MISC_IC2_CLR_TX_OVER         (IC2_ADDRESS_BASE + 0x4C)
#define RTD287o_MISC_IC2_CLR_RD_REQ          (IC2_ADDRESS_BASE + 0x50)
#define RTD287o_MISC_IC2_CLR_TX_ABRT         (IC2_ADDRESS_BASE + 0x54)
#define RTD287o_MISC_IC2_CLR_RX_DONE         (IC2_ADDRESS_BASE + 0x58)
#define RTD287o_MISC_IC2_CLR_ACTIVITY        (IC2_ADDRESS_BASE + 0x5C)
#define RTD287o_MISC_IC2_CLR_STOP_DET        (IC2_ADDRESS_BASE + 0x60)
#define RTD287o_MISC_IC2_CLR_START_DET       (IC2_ADDRESS_BASE + 0x64)
#define RTD287o_MISC_IC2_CLR_GEN_CALL        (IC2_ADDRESS_BASE + 0x68)
#define RTD287o_MISC_IC2_ENABLE              (IC2_ADDRESS_BASE + 0x6C)
#define RTD287o_MISC_IC2_STATUS              (IC2_ADDRESS_BASE + 0x70)
#define RTD287o_MISC_IC2_TXFLR               (IC2_ADDRESS_BASE + 0x74)
#define RTD287o_MISC_IC2_RXFLR               (IC2_ADDRESS_BASE + 0x78)
#define RTD287o_MISC_IC2_SDA_HOLD            (IC2_ADDRESS_BASE + 0x7C)
#define RTD287o_MISC_IC2_TX_ABRT_SOURCE      (IC2_ADDRESS_BASE + 0x80)
#define RTD287o_MISC_IC2_SLV_DATA_NACK_ONLY  (IC2_ADDRESS_BASE + 0x84)
#define RTD287o_MISC_IC2_SDA_SETUP           (IC2_ADDRESS_BASE + 0x94)
#define RTD287o_MISC_IC2_ACK_GEN_CALL        (IC2_ADDRESS_BASE + 0x98)
#define RTD287o_MISC_IC2_ENABLE_STATUS       (IC2_ADDRESS_BASE + 0x9C)
#define RTD287o_MISC_IC2_COMP_PARAM_1        (IC2_ADDRESS_BASE + 0xF4)
#define RTD287o_MISC_IC2_COMP_VERSION        (IC2_ADDRESS_BASE + 0xF8)
#define RTD287o_MISC_IC2_COMP_TYPE           (IC2_ADDRESS_BASE + 0xFC)



#define RTD287o_I2C3_GPIO_MODE_CTRL		0xB801BA00
#define RTD287o_I2C3_GUARD_INTERVAL_CTRL	0xB801BA04
#define RTD287o_I2C3_GUARD_INTERVAL_STATUS	0xB801BA08
#define RTD287o_I2C3_SDA_OUTPUT_DELAY_CTRL	0xB801BA0C


#define IC3_ADDRESS_BASE		0xB801BB00
#define RTD287o_MISC_IC3_CON		(IC3_ADDRESS_BASE)
#define RTD287o_MISC_IC3_TAR		(IC3_ADDRESS_BASE + 0x4)
#define RTD287o_MISC_IC3_SAR		(IC3_ADDRESS_BASE + 0x8)
#define RTD287o_MISC_IC3_HS_MADDR		(IC3_ADDRESS_BASE + 0xC)
#define RTD287o_MISC_IC3_DATA_CMD		(IC3_ADDRESS_BASE + 0x10)
#define RTD287o_MISC_IC3_SS_SCL_HCNT	(IC3_ADDRESS_BASE + 0x14)
#define RTD287o_MISC_IC3_SS_SCL_LCNT	(IC3_ADDRESS_BASE + 0x18)
#define RTD287o_MISC_IC3_FS_SCL_HCNT	(IC3_ADDRESS_BASE + 0x1C)
#define RTD287o_MISC_IC3_FS_SCL_LCNT	(IC3_ADDRESS_BASE + 0x20)
#define RTD287o_MISC_IC3_INTR_STAT		(IC3_ADDRESS_BASE + 0x2C)
#define RTD287o_MISC_IC3_INTR_MASK		(IC3_ADDRESS_BASE + 0x30)
#define RTD287o_MISC_IC3_RAW_INTR_STAT	(IC3_ADDRESS_BASE + 0x34)
#define RTD287o_MISC_IC3_RX_TL		(IC3_ADDRESS_BASE + 0x38)
#define RTD287o_MISC_IC3_TX_TL		(IC3_ADDRESS_BASE + 0x3C)
#define RTD287o_MISC_IC3_CLR_INTR		(IC3_ADDRESS_BASE + 0x40)
#define RTD287o_MISC_IC3_CLR_RX_UNDER	(IC3_ADDRESS_BASE + 0x44)
#define RTD287o_MISC_IC3_CLR_RX_OVER	(IC3_ADDRESS_BASE + 0x48)
#define RTD287o_MISC_IC3_CLR_TX_OVER	(IC3_ADDRESS_BASE + 0x4C)
#define RTD287o_MISC_IC3_CLR_RD_REQ		(IC3_ADDRESS_BASE + 0x50)
#define RTD287o_MISC_IC3_CLR_TX_ABRT	(IC3_ADDRESS_BASE + 0x54)
#define RTD287o_MISC_IC3_CLR_RX_DONE	(IC3_ADDRESS_BASE + 0x58)
#define RTD287o_MISC_IC3_CLR_ACTIVITY	(IC3_ADDRESS_BASE + 0x5C)
#define RTD287o_MISC_IC3_CLR_STOP_DET	(IC3_ADDRESS_BASE + 0x60)
#define RTD287o_MISC_IC3_CLR_START_DET	(IC3_ADDRESS_BASE + 0x64)
#define RTD287o_MISC_IC3_CLR_GEN_CALL	(IC3_ADDRESS_BASE + 0x68)
#define RTD287o_MISC_IC3_ENABLE		(IC3_ADDRESS_BASE + 0x6C)
#define RTD287o_MISC_IC3_STATUS		(IC3_ADDRESS_BASE + 0x70)
#define RTD287o_MISC_IC3_TXFLR		(IC3_ADDRESS_BASE + 0x74)
#define RTD287o_MISC_IC3_RXFLR		(IC3_ADDRESS_BASE + 0x78)
#define RTD287o_MISC_IC3_SDA_HOLD		(IC3_ADDRESS_BASE + 0x7C)
#define RTD287o_MISC_IC3_TX_ABRT_SOURCE	(IC3_ADDRESS_BASE + 0x80)
#define RTD287o_MISC_IC3_SLV_DATA_NACK_ONLY	(IC3_ADDRESS_BASE + 0x84)
#define RTD287o_MISC_IC3_SDA_SETUP		(IC3_ADDRESS_BASE + 0x94)
#define RTD287o_MISC_IC3_ACK_GEN_CALL	(IC3_ADDRESS_BASE + 0x98)
#define RTD287o_MISC_IC3_ENABLE_STATUS	(IC3_ADDRESS_BASE + 0x9C)
#define RTD287o_MISC_IC3_COMP_PARAM_1	(IC3_ADDRESS_BASE + 0xF4)
#define RTD287o_MISC_IC3_COMP_VERSION	(IC3_ADDRESS_BASE + 0xF8)
#define RTD287o_MISC_IC3_COMP_TYPE		(IC3_ADDRESS_BASE + 0xFC)


#define RTD287o_I2C4_GPIO_MODE_CTRL		0xB8039000
#define RTD287o_I2C4_GUARD_INTERVAL_CTRL	0xB8039004
#define RTD287o_I2C4_GUARD_INTERVAL_STATUS	0xB8039008
#define RTD287o_I2C4_SDA_OUTPUT_DELAY_CTRL	0xB803900C


#define IC4_ADDRESS_BASE		0xB8039100
#define RTD287o_MISC_IC4_CON		(IC4_ADDRESS_BASE)
#define RTD287o_MISC_IC4_TAR		(IC4_ADDRESS_BASE + 0x4)
#define RTD287o_MISC_IC4_SAR		(IC4_ADDRESS_BASE + 0x8)
#define RTD287o_MISC_IC4_HS_MADDR		(IC4_ADDRESS_BASE + 0xC)
#define RTD287o_MISC_IC4_DATA_CMD		(IC4_ADDRESS_BASE + 0x10)
#define RTD287o_MISC_IC4_SS_SCL_HCNT	(IC4_ADDRESS_BASE + 0x14)
#define RTD287o_MISC_IC4_SS_SCL_LCNT	(IC4_ADDRESS_BASE + 0x18)
#define RTD287o_MISC_IC4_FS_SCL_HCNT	(IC4_ADDRESS_BASE + 0x1C)
#define RTD287o_MISC_IC4_FS_SCL_LCNT	(IC4_ADDRESS_BASE + 0x20)
#define RTD287o_MISC_IC4_INTR_STAT		(IC4_ADDRESS_BASE + 0x2C)
#define RTD287o_MISC_IC4_INTR_MASK		(IC4_ADDRESS_BASE + 0x30)
#define RTD287o_MISC_IC4_RAW_INTR_STAT	(IC4_ADDRESS_BASE + 0x34)
#define RTD287o_MISC_IC4_RX_TL		(IC4_ADDRESS_BASE + 0x38)
#define RTD287o_MISC_IC4_TX_TL		(IC4_ADDRESS_BASE + 0x3C)
#define RTD287o_MISC_IC4_CLR_INTR		(IC4_ADDRESS_BASE + 0x40)
#define RTD287o_MISC_IC4_CLR_RX_UNDER	(IC4_ADDRESS_BASE + 0x44)
#define RTD287o_MISC_IC4_CLR_RX_OVER	(IC4_ADDRESS_BASE + 0x48)
#define RTD287o_MISC_IC4_CLR_TX_OVER	(IC4_ADDRESS_BASE + 0x4C)
#define RTD287o_MISC_IC4_CLR_RD_REQ		(IC4_ADDRESS_BASE + 0x50)
#define RTD287o_MISC_IC4_CLR_TX_ABRT	(IC4_ADDRESS_BASE + 0x54)
#define RTD287o_MISC_IC4_CLR_RX_DONE	(IC4_ADDRESS_BASE + 0x58)
#define RTD287o_MISC_IC4_CLR_ACTIVITY	(IC4_ADDRESS_BASE + 0x5C)
#define RTD287o_MISC_IC4_CLR_STOP_DET	(IC4_ADDRESS_BASE + 0x60)
#define RTD287o_MISC_IC4_CLR_START_DET	(IC4_ADDRESS_BASE + 0x64)
#define RTD287o_MISC_IC4_CLR_GEN_CALL	(IC4_ADDRESS_BASE + 0x68)
#define RTD287o_MISC_IC4_ENABLE		(IC4_ADDRESS_BASE + 0x6C)
#define RTD287o_MISC_IC4_STATUS		(IC4_ADDRESS_BASE + 0x70)
#define RTD287o_MISC_IC4_TXFLR		(IC4_ADDRESS_BASE + 0x74)
#define RTD287o_MISC_IC4_RXFLR		(IC4_ADDRESS_BASE + 0x78)
#define RTD287o_MISC_IC4_SDA_HOLD		(IC4_ADDRESS_BASE + 0x7C)
#define RTD287o_MISC_IC4_TX_ABRT_SOURCE	(IC4_ADDRESS_BASE + 0x80)
#define RTD287o_MISC_IC4_SLV_DATA_NACK_ONLY	(IC4_ADDRESS_BASE + 0x84)
#define RTD287o_MISC_IC4_SDA_SETUP		(IC4_ADDRESS_BASE + 0x94)
#define RTD287o_MISC_IC4_ACK_GEN_CALL	(IC4_ADDRESS_BASE + 0x98)
#define RTD287o_MISC_IC4_ENABLE_STATUS	(IC4_ADDRESS_BASE + 0x9C)
#define RTD287o_MISC_IC4_COMP_PARAM_1	(IC4_ADDRESS_BASE + 0xF4)
#define RTD287o_MISC_IC4_COMP_VERSION	(IC4_ADDRESS_BASE + 0xF8)
#define RTD287o_MISC_IC4_COMP_TYPE		(IC4_ADDRESS_BASE + 0xFC)

#define RTD287o_I2C5_GPIO_MODE_CTRL			(0xB8062700)
#define RTD287o_I2C5_GUARD_INTERVAL_CTRL		(0xB8062704)
#define RTD287o_I2C5_GUARD_INTERVAL_STATUS		(0xB8062708)
#define RTD287o_I2C5_SDA_OUTPUT_DELAY_CTRL		(0xB806270C)

#define IC5_ADDRESS_BASE		(0xB8062800)
#define RTD287o_ISO_IC5_CON			IC5_ADDRESS_BASE
#define RTD287o_ISO_IC5_TAR			(IC5_ADDRESS_BASE + 0x4)
#define RTD287o_ISO_IC5_SAR			(IC5_ADDRESS_BASE + 0x8)
#define RTD287o_ISO_IC5_HS_MADDR		(IC5_ADDRESS_BASE + 0xC)
#define RTD287o_ISO_IC5_DATA_CMD		(IC5_ADDRESS_BASE + 0x10)
#define RTD287o_ISO_IC5_SS_SCL_HCNT		(IC5_ADDRESS_BASE + 0x14)
#define RTD287o_ISO_IC5_SS_SCL_LCNT		(IC5_ADDRESS_BASE + 0x18)
#define RTD287o_ISO_IC5_FS_SCL_HCNT		(IC5_ADDRESS_BASE + 0x1C)
#define RTD287o_ISO_IC5_FS_SCL_LCNT		(IC5_ADDRESS_BASE + 0x20)
#define RTD287o_ISO_IC5_INTR_STAT		(IC5_ADDRESS_BASE + 0x2C)
#define RTD287o_ISO_IC5_INTR_MASK		(IC5_ADDRESS_BASE + 0x30)
#define RTD287o_ISO_IC5_RAW_INTR_STAT	(IC5_ADDRESS_BASE + 0x34)
#define RTD287o_ISO_IC5_RX_TL		(IC5_ADDRESS_BASE + 0x38)
#define RTD287o_ISO_IC5_TX_TL		(IC5_ADDRESS_BASE + 0x3C)
#define RTD287o_ISO_IC5_CLR_INTR		(IC5_ADDRESS_BASE + 0x40)
#define RTD287o_ISO_IC5_CLR_RX_UNDER	(IC5_ADDRESS_BASE + 0x44)
#define RTD287o_ISO_IC5_CLR_RX_OVER		(IC5_ADDRESS_BASE + 0x48)
#define RTD287o_ISO_IC5_CLR_TX_OVER		(IC5_ADDRESS_BASE + 0x4C)
#define RTD287o_ISO_IC5_CLR_RD_REQ		(IC5_ADDRESS_BASE + 0x50)
#define RTD287o_ISO_IC5_CLR_TX_ABRT		(IC5_ADDRESS_BASE + 0x54)
#define RTD287o_ISO_IC5_CLR_RX_DONE		(IC5_ADDRESS_BASE + 0x58)
#define RTD287o_ISO_IC5_CLR_ACTIVITY	(IC5_ADDRESS_BASE + 0x5C)
#define RTD287o_ISO_IC5_CLR_STOP_DET	(IC5_ADDRESS_BASE + 0x60)
#define RTD287o_ISO_IC5_CLR_START_DET	(IC5_ADDRESS_BASE + 0x64)
#define RTD287o_ISO_IC5_CLR_GEN_CALL	(IC5_ADDRESS_BASE + 0x68)
#define RTD287o_ISO_IC5_ENABLE		(IC5_ADDRESS_BASE + 0x6C)
#define RTD287o_ISO_IC5_STATUS		(IC5_ADDRESS_BASE + 0x70)
#define RTD287o_ISO_IC5_TXFLR		(IC5_ADDRESS_BASE + 0x74)
#define RTD287o_ISO_IC5_RXFLR		(IC5_ADDRESS_BASE + 0x78)
#define RTD287o_ISO_IC5_SDA_HOLD		(IC5_ADDRESS_BASE + 0x7C)
#define RTD287o_ISO_IC5_TX_ABRT_SOURCE	(IC5_ADDRESS_BASE + 0x80)
#define RTD287o_ISO_IC5_SLV_DATA_NACK_ONLY	(IC5_ADDRESS_BASE + 0x84)
#define RTD287o_ISO_IC5_SDA_SETUP		(IC5_ADDRESS_BASE + 0x94)
#define RTD287o_ISO_IC5_ACK_GEN_CALL	(IC5_ADDRESS_BASE + 0x98)
#define RTD287o_ISO_IC5_ENABLE_STATUS	(IC5_ADDRESS_BASE + 0x9C)
#define RTD287o_ISO_IC5_COMP_PARAM_1	(IC5_ADDRESS_BASE + 0xF4)
#define RTD287o_ISO_IC5_COMP_VERSION	(IC5_ADDRESS_BASE + 0xF8)
#define RTD287o_ISO_IC5_COMP_TYPE		(IC5_ADDRESS_BASE + 0xFC)

// I2C
unsigned int IC_CON[]             = {RTD287o_ISO_IC0_CON            ,RTD287o_MISC_IC1_CON            ,RTD287o_MISC_IC2_CON              ,RTD287o_MISC_IC3_CON              ,RTD287o_MISC_IC4_CON              ,RTD287o_ISO_IC5_CON};
unsigned int IC_TAR[]             = {RTD287o_ISO_IC0_TAR            ,RTD287o_MISC_IC1_TAR            ,RTD287o_MISC_IC2_TAR              ,RTD287o_MISC_IC3_TAR              ,RTD287o_MISC_IC4_TAR              ,RTD287o_ISO_IC5_TAR};
unsigned int IC_SAR[]             = {RTD287o_ISO_IC0_SAR            ,RTD287o_MISC_IC1_SAR            ,RTD287o_MISC_IC2_SAR              ,RTD287o_MISC_IC3_SAR              ,RTD287o_MISC_IC4_SAR              ,RTD287o_ISO_IC5_SAR};
unsigned int IC_HS_MADDR[]        = {RTD287o_ISO_IC0_HS_MADDR       ,RTD287o_MISC_IC1_HS_MADDR       ,RTD287o_MISC_IC2_HS_MADDR         ,RTD287o_MISC_IC3_HS_MADDR         ,RTD287o_MISC_IC4_HS_MADDR         ,RTD287o_ISO_IC5_HS_MADDR};
unsigned int IC_DATA_CMD[]        = {RTD287o_ISO_IC0_DATA_CMD       ,RTD287o_MISC_IC1_DATA_CMD       ,RTD287o_MISC_IC2_DATA_CMD         ,RTD287o_MISC_IC3_DATA_CMD         ,RTD287o_MISC_IC4_DATA_CMD         ,RTD287o_ISO_IC5_DATA_CMD};
unsigned int IC_SS_SCL_HCNT[]     = {RTD287o_ISO_IC0_SS_SCL_HCNT    ,RTD287o_MISC_IC1_SS_SCL_HCNT    ,RTD287o_MISC_IC2_SS_SCL_HCNT      ,RTD287o_MISC_IC3_SS_SCL_HCNT      ,RTD287o_MISC_IC4_SS_SCL_HCNT      ,RTD287o_ISO_IC5_SS_SCL_HCNT};
unsigned int IC_SS_SCL_LCNT[]     = {RTD287o_ISO_IC0_SS_SCL_LCNT    ,RTD287o_MISC_IC1_SS_SCL_LCNT    ,RTD287o_MISC_IC2_SS_SCL_LCNT      ,RTD287o_MISC_IC3_SS_SCL_LCNT      ,RTD287o_MISC_IC4_SS_SCL_LCNT      ,RTD287o_ISO_IC5_SS_SCL_LCNT};
unsigned int IC_FS_SCL_HCNT[]     = {RTD287o_ISO_IC0_FS_SCL_HCNT    ,RTD287o_MISC_IC1_FS_SCL_HCNT    ,RTD287o_MISC_IC2_FS_SCL_HCNT      ,RTD287o_MISC_IC3_FS_SCL_HCNT      ,RTD287o_MISC_IC4_FS_SCL_HCNT      ,RTD287o_ISO_IC5_FS_SCL_HCNT};
unsigned int IC_FS_SCL_LCNT[]     = {RTD287o_ISO_IC0_FS_SCL_LCNT    ,RTD287o_MISC_IC1_FS_SCL_LCNT    ,RTD287o_MISC_IC2_FS_SCL_LCNT      ,RTD287o_MISC_IC3_FS_SCL_LCNT      ,RTD287o_MISC_IC4_FS_SCL_LCNT      ,RTD287o_ISO_IC5_FS_SCL_LCNT};
unsigned int IC_INTR_STAT[]       = {RTD287o_ISO_IC0_INTR_STAT      ,RTD287o_MISC_IC1_INTR_STAT      ,RTD287o_MISC_IC2_INTR_STAT        ,RTD287o_MISC_IC3_INTR_STAT        ,RTD287o_MISC_IC4_INTR_STAT        ,RTD287o_ISO_IC5_INTR_STAT};
unsigned int IC_INTR_MASK[]       = {RTD287o_ISO_IC0_INTR_MASK      ,RTD287o_MISC_IC1_INTR_MASK      ,RTD287o_MISC_IC2_INTR_MASK        ,RTD287o_MISC_IC3_INTR_MASK        ,RTD287o_MISC_IC4_INTR_MASK        ,RTD287o_ISO_IC5_INTR_MASK};
unsigned int IC_RAW_INTR_STAT[]   = {RTD287o_ISO_IC0_RAW_INTR_STAT  ,RTD287o_MISC_IC1_RAW_INTR_STAT  ,RTD287o_MISC_IC2_RAW_INTR_STAT    ,RTD287o_MISC_IC3_RAW_INTR_STAT    ,RTD287o_MISC_IC4_RAW_INTR_STAT    ,RTD287o_ISO_IC5_RAW_INTR_STAT};
unsigned int IC_RX_TL[]           = {RTD287o_ISO_IC0_RX_TL          ,RTD287o_MISC_IC1_RX_TL          ,RTD287o_MISC_IC2_RX_TL            ,RTD287o_MISC_IC3_RX_TL            ,RTD287o_MISC_IC4_RX_TL            ,RTD287o_ISO_IC5_RX_TL};
unsigned int IC_TX_TL[]           = {RTD287o_ISO_IC0_TX_TL          ,RTD287o_MISC_IC1_TX_TL          ,RTD287o_MISC_IC2_TX_TL            ,RTD287o_MISC_IC3_TX_TL            ,RTD287o_MISC_IC4_TX_TL            ,RTD287o_ISO_IC5_TX_TL};
unsigned int IC_CLR_INTR[]        = {RTD287o_ISO_IC0_CLR_INTR       ,RTD287o_MISC_IC1_CLR_INTR       ,RTD287o_MISC_IC2_CLR_INTR         ,RTD287o_MISC_IC3_CLR_INTR         ,RTD287o_MISC_IC4_CLR_INTR         ,RTD287o_ISO_IC5_CLR_INTR};
unsigned int IC_CLR_RX_UNDER[]    = {RTD287o_ISO_IC0_CLR_RX_UNDER   ,RTD287o_MISC_IC1_CLR_RX_UNDER   ,RTD287o_MISC_IC2_CLR_RX_UNDER     ,RTD287o_MISC_IC3_CLR_RX_UNDER     ,RTD287o_MISC_IC4_CLR_RX_UNDER     ,RTD287o_ISO_IC5_CLR_RX_UNDER};
unsigned int IC_CLR_RX_OVER[]     = {RTD287o_ISO_IC0_CLR_RX_OVER    ,RTD287o_MISC_IC1_CLR_RX_OVER    ,RTD287o_MISC_IC2_CLR_RX_OVER      ,RTD287o_MISC_IC3_CLR_RX_OVER      ,RTD287o_MISC_IC4_CLR_RX_OVER      ,RTD287o_ISO_IC5_CLR_RX_OVER};
unsigned int IC_CLR_TX_OVER[]     = {RTD287o_ISO_IC0_CLR_TX_OVER    ,RTD287o_MISC_IC1_CLR_TX_OVER    ,RTD287o_MISC_IC2_CLR_TX_OVER      ,RTD287o_MISC_IC3_CLR_TX_OVER      ,RTD287o_MISC_IC4_CLR_TX_OVER      ,RTD287o_ISO_IC5_CLR_TX_OVER};
unsigned int IC_CLR_RD_REQ[]      = {RTD287o_ISO_IC0_CLR_RD_REQ     ,RTD287o_MISC_IC1_CLR_RD_REQ     ,RTD287o_MISC_IC2_CLR_RD_REQ       ,RTD287o_MISC_IC3_CLR_RD_REQ       ,RTD287o_MISC_IC4_CLR_RD_REQ       ,RTD287o_ISO_IC5_CLR_RD_REQ};
unsigned int IC_CLR_TX_ABRT[]     = {RTD287o_ISO_IC0_CLR_TX_ABRT    ,RTD287o_MISC_IC1_CLR_TX_ABRT    ,RTD287o_MISC_IC2_CLR_TX_ABRT      ,RTD287o_MISC_IC3_CLR_TX_ABRT      ,RTD287o_MISC_IC4_CLR_TX_ABRT      ,RTD287o_ISO_IC5_CLR_TX_ABRT};
unsigned int IC_CLR_RX_DONE[]     = {RTD287o_ISO_IC0_CLR_RX_DONE    ,RTD287o_MISC_IC1_CLR_RX_DONE    ,RTD287o_MISC_IC2_CLR_RX_DONE      ,RTD287o_MISC_IC3_CLR_RX_DONE      ,RTD287o_MISC_IC4_CLR_RX_DONE      ,RTD287o_ISO_IC5_CLR_RX_DONE};
unsigned int IC_CLR_ACTIVITY[]    = {RTD287o_ISO_IC0_CLR_ACTIVITY   ,RTD287o_MISC_IC1_CLR_ACTIVITY   ,RTD287o_MISC_IC2_CLR_ACTIVITY     ,RTD287o_MISC_IC3_CLR_ACTIVITY     ,RTD287o_MISC_IC4_CLR_ACTIVITY     ,RTD287o_ISO_IC5_CLR_ACTIVITY};
unsigned int IC_CLR_STOP_DET[]    = {RTD287o_ISO_IC0_CLR_STOP_DET   ,RTD287o_MISC_IC1_CLR_STOP_DET   ,RTD287o_MISC_IC2_CLR_STOP_DET     ,RTD287o_MISC_IC3_CLR_STOP_DET     ,RTD287o_MISC_IC4_CLR_STOP_DET     ,RTD287o_ISO_IC5_CLR_STOP_DET};
unsigned int IC_CLR_START_DET[]   = {RTD287o_ISO_IC0_CLR_START_DET  ,RTD287o_MISC_IC1_CLR_START_DET  ,RTD287o_MISC_IC2_CLR_START_DET    ,RTD287o_MISC_IC3_CLR_START_DET    ,RTD287o_MISC_IC4_CLR_START_DET    ,RTD287o_ISO_IC5_CLR_START_DET};
unsigned int IC_CLR_GEN_CALL[]    = {RTD287o_ISO_IC0_CLR_GEN_CALL   ,RTD287o_MISC_IC1_CLR_GEN_CALL   ,RTD287o_MISC_IC2_CLR_GEN_CALL     ,RTD287o_MISC_IC3_CLR_GEN_CALL     ,RTD287o_MISC_IC4_CLR_GEN_CALL     ,RTD287o_ISO_IC5_CLR_GEN_CALL};
unsigned int IC_ENABLE[]          = {RTD287o_ISO_IC0_ENABLE         ,RTD287o_MISC_IC1_ENABLE         ,RTD287o_MISC_IC2_ENABLE           ,RTD287o_MISC_IC3_ENABLE           ,RTD287o_MISC_IC4_ENABLE           ,RTD287o_ISO_IC5_ENABLE};
unsigned int IC_STATUS[]          = {RTD287o_ISO_IC0_STATUS         ,RTD287o_MISC_IC1_STATUS         ,RTD287o_MISC_IC2_STATUS           ,RTD287o_MISC_IC3_STATUS           ,RTD287o_MISC_IC4_STATUS           ,RTD287o_ISO_IC5_STATUS};
unsigned int IC_TXFLR[]           = {RTD287o_ISO_IC0_TXFLR          ,RTD287o_MISC_IC1_TXFLR          ,RTD287o_MISC_IC2_TXFLR            ,RTD287o_MISC_IC3_TXFLR            ,RTD287o_MISC_IC4_TXFLR            ,RTD287o_ISO_IC5_TXFLR};
unsigned int IC_RXFLR[]           = {RTD287o_ISO_IC0_RXFLR          ,RTD287o_MISC_IC1_RXFLR          ,RTD287o_MISC_IC2_RXFLR            ,RTD287o_MISC_IC3_RXFLR            ,RTD287o_MISC_IC4_RXFLR            ,RTD287o_ISO_IC5_RXFLR};
unsigned int IC_SDA_HOLD[]        = {RTD287o_ISO_IC0_SDA_HOLD       ,RTD287o_MISC_IC1_SDA_HOLD       ,RTD287o_MISC_IC2_SDA_HOLD         ,RTD287o_MISC_IC3_SDA_HOLD         ,RTD287o_MISC_IC4_SDA_HOLD         ,RTD287o_ISO_IC5_SDA_HOLD};
unsigned int IC_TX_ABRT_SOURCE[]  = {RTD287o_ISO_IC0_TX_ABRT_SOURCE ,RTD287o_MISC_IC1_TX_ABRT_SOURCE ,RTD287o_MISC_IC2_TX_ABRT_SOURCE   ,RTD287o_MISC_IC3_TX_ABRT_SOURCE   ,RTD287o_MISC_IC4_TX_ABRT_SOURCE   ,RTD287o_ISO_IC5_TX_ABRT_SOURCE};
unsigned int IC_SLV_DATA_NACK_ONLY[]= {RTD287o_ISO_IC0_SLV_DATA_NACK_ONLY ,RTD287o_MISC_IC1_SLV_DATA_NACK_ONLY ,RTD287o_MISC_IC2_SLV_DATA_NACK_ONLY   ,RTD287o_MISC_IC3_SLV_DATA_NACK_ONLY   ,RTD287o_MISC_IC4_SLV_DATA_NACK_ONLY   ,RTD287o_ISO_IC5_SLV_DATA_NACK_ONLY};
unsigned int IC_TX_SDA_SETUP[]    = {RTD287o_ISO_IC0_SDA_SETUP      ,RTD287o_MISC_IC1_SDA_SETUP      ,RTD287o_MISC_IC2_SDA_SETUP        ,RTD287o_MISC_IC3_SDA_SETUP        ,RTD287o_MISC_IC4_SDA_SETUP        ,RTD287o_ISO_IC5_SDA_SETUP};
unsigned int IC_TX_ACK_GEN_CALL[] = {RTD287o_ISO_IC0_ACK_GEN_CALL   ,RTD287o_MISC_IC1_ACK_GEN_CALL   ,RTD287o_MISC_IC2_ACK_GEN_CALL     ,RTD287o_MISC_IC3_ACK_GEN_CALL     ,RTD287o_MISC_IC4_ACK_GEN_CALL     ,RTD287o_ISO_IC5_ACK_GEN_CALL};
unsigned int IC_DMA_ENABLE_STATUS[]= {RTD287o_ISO_IC0_ENABLE_STATUS ,RTD287o_MISC_IC1_ENABLE_STATUS  ,RTD287o_MISC_IC2_ENABLE_STATUS    ,RTD287o_MISC_IC3_ENABLE_STATUS    ,RTD287o_MISC_IC4_ENABLE_STATUS    ,RTD287o_ISO_IC5_ENABLE_STATUS};
unsigned int IC_COMP_PARAM_1[]    = {RTD287o_ISO_IC0_COMP_PARAM_1   ,RTD287o_MISC_IC1_COMP_PARAM_1   ,RTD287o_MISC_IC2_COMP_PARAM_1     ,RTD287o_MISC_IC3_COMP_PARAM_1     ,RTD287o_MISC_IC4_COMP_PARAM_1     ,RTD287o_ISO_IC5_COMP_PARAM_1};
unsigned int IC_COMP_VERSION[]    = {RTD287o_ISO_IC0_COMP_VERSION   ,RTD287o_MISC_IC1_COMP_VERSION   ,RTD287o_MISC_IC2_COMP_VERSION     ,RTD287o_MISC_IC3_COMP_VERSION     ,RTD287o_MISC_IC4_COMP_VERSION     ,RTD287o_ISO_IC5_COMP_VERSION};
unsigned int IC_COMP_TYPE[]       = {RTD287o_ISO_IC0_COMP_TYPE      ,RTD287o_MISC_IC1_COMP_TYPE      ,RTD287o_MISC_IC2_COMP_TYPE        ,RTD287o_MISC_IC3_COMP_TYPE        ,RTD287o_MISC_IC4_COMP_TYPE        ,RTD287o_ISO_IC5_COMP_TYPE};
 

//IC_CON
#define IC_SLAVE_DISABLE    0x0040
#define IC_RESTART_EN       0x0020
#define IC_10BITADDR_MASTER 0x0010
#define IC_10BITADDR_SLAVE  0x0008
#define IC_MASTER_MODE      0x0001

#define IC_SPEED            0x0006
#define SPEED_SS            0x0002
#define SPEED_FS            0x0004
#define SPEED_HS            0x0006

//ID_DATA
#define READ_CMD            0x0100

// INT
#define GEN_CALL_BIT        0x800
#define START_DET_BIT       0x400
#define STOP_DET_BIT        0x200
#define ACTIVITY_BIT        0x100
#define RX_DONE_BIT         0x080
#define TX_ABRT_BIT         0x040
#define RD_REQ_BIT          0x020
#define TX_EMPTY_BIT        0x010
#define TX_OVER_BIT         0x008
#define RX_FULL_BIT         0x004
#define RX_OVER_BIT         0x002
#define RX_UNDER_BIT        0x001

// STATUS
#define ST_RFF_BIT          0x10
#define ST_RFNE_BIT         0x08
#define ST_TFE_BIT          0x04
#define ST_TFNF_BIT         0x02
#define ST_ACTIVITY_BIT     0x01

// MIS_ISR
// I2C0 interrupt flag. Ref doc sisius-ISO_MISC_OFF_arch_spec
#define I2C0_INT                    (0x00000001<<1)
#define I2C1_INT                    (0x00000001<<27)
#define I2C2_INT                    (0x00000001<<26)
#define I2C3_INT                    (0x00000001<<25)
#define I2C4_INT                   (0x00000001<<22)
#define I2C5_INT					(0x00000001<<0)


// IC_TX_ABRT_SOURCE
#define ABRT_SLVRD_INTX             0x8000
#define ABRT_SLV_ARB_LOST           0x4000
#define ABRT_SLV_FLUSH_TX_FIFO      0x2000
#define ABRT_ARB_LOST               0x1000
#define ABR_MASTER_DIS              0x0800
#define ABRT_10B_RD_NORSTRT         0x0400
#define ABRT_SBYTE_NORSTRT          0x0200
#define ABRT_HS_NORSTRT             0x0100
#define ABRT_SBYTE_ACKDET           0x0080
#define ABRT_HS_ACKDET              0x0040
#define ABRT_GCALL_READ             0x0020
#define ABRT_GCALL_NOACK            0x0010
#define ABRT_TXDATA_NOACK           0x0008
#define ABRT_10ADDR2_NOACK          0x0004
#define ABRT_10ADDR1_NOACK          0x0002
#define ABRT_7ADDR_NOACK            0x0001

#endif
