#ifndef __RTK_I2C_LIB_H__
#define __RTK_I2C_LIB_H__

#include <platform_lib/board/pcb.h>

#ifndef I2C_PORT_0
#define I2C_PORT_0  I2C_PORT_UNUSED
#endif
#ifndef I2C_PORT_1
#define I2C_PORT_1  I2C_PORT_UNUSED
#endif
#ifndef I2C_PORT_2
#define I2C_PORT_2  I2C_PORT_UNUSED
#endif
#ifndef I2C_PORT_3
#define I2C_PORT_3  I2C_PORT_UNUSED
#endif
#ifndef I2C_PORT_4
#define I2C_PORT_4  I2C_PORT_UNUSED
#endif
#ifndef I2C_PORT_5
#define I2C_PORT_5  I2C_PORT_UNUSED
#endif

#define S_OK         0
#define S_FALSE     -1

#define GET_I2C_TYPE(cfg)       ((cfg >> 32) & 0x1)
#define GET_HW_I2C_PHY(cfg)     ((cfg >> 4)  & 0x7)
#define GET_HW_I2C_SRC(cfg)     (cfg & 0xF)

#define MAX_TEST_I2C_DEV_ONE_PORT    (6)

typedef struct {
    unsigned char port_id;
    PCB_I2C_TYPE_T      i2c_type;
    int                 I2C_speed_KHz;
    unsigned char       i2c_phy_addr;
    unsigned char       i2c_bus_src;
    char                flag;
    unsigned char dev_Counter;
    unsigned char       device_addr[MAX_TEST_I2C_DEV_ONE_PORT];
} rtk_i2c_device_addr;

extern void I2C_Init(void);
extern int I2C_Write_EX(unsigned char PortId, unsigned short Addr, unsigned short nData, unsigned char* pData);
extern int I2C_Read_EX(unsigned char PortId, unsigned short Addr, unsigned short nSubAddr, unsigned char* pSubAddr, unsigned short nData, unsigned char* pData);
#ifdef CONFIG_PANEL_SHARP_60_MEMC
extern int I2C_Write_EX2(unsigned short Addr, unsigned char nSubAddr, unsigned char* pSubAddr, unsigned short nData, unsigned char* pData);
extern int I2C_Read_EX2(unsigned short Addr, unsigned char nSubAddr, unsigned char* pSubAddr, unsigned short nData, unsigned char* pData);
#endif //#ifdef CONFIG_PANEL_SHARP_60_MEMC
extern int I2C_SetSpeed(unsigned char PortId, int KHz);

extern int I2C_StartXfer(
    unsigned char           PortId,
    unsigned short          Addr,
    unsigned short          nSubAddr,
    unsigned char*          pSubAddr,
    unsigned short          nData,
    unsigned char*          pData
);

extern unsigned char I2C_GetBusCount(void);

#endif

