#include <panel.h>
#include <asm/arch/panel_config_parameter.h>

#ifndef CONFIG_CUSTOM_SN_PANEL

//#define PANEL_NUM 16
#define PANEL_NUM 22


static const PANEL_CONFIG_PARAMETER panel_setting[PANEL_NUM] =
{
	{ //RTK_4K2K_VBY1_1Seg8Port.h- 0
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

    	.iCONFIG_CUSTOMER_PANEL_ID=0,
    
		.iPANEL_WIDTH_MM = 626,
		.iPANEL_HEIGHT_MM = 348,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="RTK_4K2K_VBY1_1Seg8Port.h"
	},
	{ //China_Star_4K2K_VBY1.h - 1
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=1,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_CHINASTAR_4K2K_600M_2S_8L,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,
		
		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="China_Star_4K2K_VBY1.h"
	},
	{ //Skyworth_4K2K_VBY1.h - 2
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_INX8903_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,
		
		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="Skyworth_Default_4K2K_VBY1.h"
	},
    { //LG_4k2k_600M_VBY1_1Seg8Port.h - 3
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=127,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_TO_HDMI,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

	        	.iCONFIG_CUSTOMER_PANEL_ID=0,
	        	
	    .iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="LG_Vby1_To_HDMI.h"
	},
	{ //RTK VB1 to LVDS panel - 4
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=127,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x02020202,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x02020202,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=4,
		.iCONFIG_PANEL_TYPE=P_VBY1_TO_LVDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_RTK_VB1_4K2K_TO_LVDS,

		.i3D_DISPLAY_TIMING=0,

	        .iCONFIG_CUSTOMER_PANEL_ID=0,
	        
		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="RTK_Vby1_To_LVDS.h"
	},
	{ //RTK VB1 to LVDS panel - 5
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=127,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x02020202,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x02020202,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=4,
		.iCONFIG_PANEL_TYPE=P_VBY1_TO_LVDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_RTK_VB1_4K2K_TO_LVDS_NEW_VER,

		.i3D_DISPLAY_TIMING=0,

	        .iCONFIG_CUSTOMER_PANEL_ID=0,
	        
		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="RTK_Vby1_To_LVDS_New.h"
	},
	{ //CSOT_4K_mLVDS_GOA - 6
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=600,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=4,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_MINI_LVDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_MINI_LVDS_CSOT_PANEL,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="CSOT_4K_mLVDS_GOA.h"
	},
	{ // LG_HV490QUB CEDS - 7
		.iCONFIG_DISPLAY_PORT=2,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=0,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=63,
		.iCONFIG_DISP_VSYNC_LENGTH=3,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=240,
		.iCONFIG_BACKLIGHT_PWM_DUTY=10,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=1,
		.i3D_LINE_ALTERNATIVE_SUPPORT=1,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=1,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x543210ba,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x98765432,
		.iCONFIG_SR_MODE=3,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=6,
		.iCONFIG_SFG_PORT_NUM=6,
		.iCONFIG_PANEL_TYPE=P_CEDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_CEDS_LG_HV490QUB_UHD60_12LANE,

		.i3D_DISPLAY_TIMING=_3D_TIMING_2K1K_60,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		
		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="LG_HV490QUB_UHD60_CEDS_12LANE.h"
	},
	{	// BOE_HV550QUB_H81 CEDS - 8
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=600,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_CEDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_CEDS_BOE_HV550QUB_H81_PANEL,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,
		
		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="CEDS_BOE_HV550QUB_H81_PANEL.h"
	},
	{ //LG_V18_65UHD60_EPI_8LANE - 9
		.iCONFIG_DISPLAY_PORT=2,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=0,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=63,
		.iCONFIG_DISP_VSYNC_LENGTH=3,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=240,
		.iCONFIG_BACKLIGHT_PWM_DUTY=10,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=1,
		.i3D_LINE_ALTERNATIVE_SUPPORT=1,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=1,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x543210ba,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x98765432,
		.iCONFIG_SR_MODE=3,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=6,
		.iCONFIG_SFG_PORT_NUM=6,
		.iCONFIG_PANEL_TYPE=P_EPI_TYPE,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_EPI_LG_V18_65INCH_UHD60_8LANE,

		.i3D_DISPLAY_TIMING=_3D_TIMING_2K1K_60,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		
		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="LG_V18_65UHD60_EPI_8LANE.h"
	},
		{ //4K mLVDS 4port_6pair- sharp - 10
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=600,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_MINI_LVDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_MINI_LVDS_SHARP_70_PANEL,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,
		
		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="SHARP_4K_70Inch_mLVDS.h "
	},
		{ //default_panel.h - 11
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=1,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=0,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=154,
		.iCONFIG_DISPLAY_CLOCK_MIN=126,
		.iCONFIG_DISPLAY_REFRESH_RATE=75,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=149*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL=1125,

		.iCONFIG_DISP_HSYNC_WIDTH=31,
		.iCONFIG_DISP_VSYNC_LENGTH=3,

		.iCONFIG_DISP_DEN_STA_HPOS=140,
		.iCONFIG_DISP_DEN_END_HPOS=2060,
		.iCONFIG_DISP_DEN_STA_VPOS=16,
		.iCONFIG_DISP_DEN_END_VPOS=1096,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=1920,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=1080,

		.iCONFIG_DISP_HSYNC_LASTLINE=2199,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=240,
		.iCONFIG_BACKLIGHT_PWM_DUTY=10,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=1308,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=1380,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=1100,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=1149,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x10000,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0,
		.iCONFIG_SR_MODE=3,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=0,
		.iCONFIG_SFG_PORT_NUM=0,
		.iCONFIG_PANEL_TYPE=0,
		.iCONFIG_PANEL_CUSTOM_INDEX=0,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		
		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="benq22_default_panel.h"
	},
		{ //CHPI_55INCH_UHD60_6LANE_HIMAX.h - 12
		.iCONFIG_DISPLAY_PORT=2,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=0,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=63,
		.iCONFIG_DISP_VSYNC_LENGTH=3,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=240,
		.iCONFIG_BACKLIGHT_PWM_DUTY=10,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=1,
		.i3D_LINE_ALTERNATIVE_SUPPORT=1,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=1,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x543210ba,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x98765432,
		.iCONFIG_SR_MODE=3,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=6,
		.iCONFIG_SFG_PORT_NUM=6,
		.iCONFIG_PANEL_TYPE=P_CHPI,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_CHPI_55INCH_UHD60_6LANE_RAYDIUM,

		.i3D_DISPLAY_TIMING=_3D_TIMING_2K1K_60,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		
		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="CHPI_55INCH_UHD60_RAYDIUM.h"
	},
	{ //CEDS_BOE_HV550QUB_H81_PANEL - 13
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=600,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_CEDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_CEDS_BOE_HV550QUB_H81_PANEL,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,
		
		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="CEDS_BOE_HV550QUB_H81_PANEL.h "
	},
	{ //CEDS_BOE_HV550QUB_H81_PANEL - 14
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=600,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=12,
		.iCONFIG_SFG_PORT_NUM=12,
		.iCONFIG_PANEL_TYPE=P_ISP,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_ISP_50INCH_UHD60_12LANE,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,
		
		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="ISP_50_UHD_12LANE_PANEL.h "
	},
	{ //Vby1_To_LVDS_To_HDMI - 15
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=127,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x02020202,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x02020202,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=4,
		.iCONFIG_PANEL_TYPE=P_VBY1_TO_LVDS_TO_HDMI,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		
		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="Vby1_To_LVDS_To_HDMI.h"
	},
	{ //Samsung_LSC650FN10_Panel - 16
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=614,
		.iCONFIG_DISPLAY_CLOCK_MIN=480,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=20,
		.iLVDS_TO_LIGHT_ON_ms=1010,

		.iLIGHT_TO_LDVS_OFF_ms=110,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=60,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2850,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2850,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=1,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_SAMSUNG_LSC650FN10_4K2K_2S_8L,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="SAMSUNG_LSC650FN10_4K2K_Vby1.h"
	},
	{ //Samsung_LSC750FF03-G_Panel - 17, 120Hz panel, it need to confirm with MEMC chip
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=1228,
		.iCONFIG_DISPLAY_CLOCK_MIN=960,
		.iCONFIG_DISPLAY_REFRESH_RATE=120,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=1188*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=20,
		.iLVDS_TO_LIGHT_ON_ms=1010,

		.iLIGHT_TO_LDVS_OFF_ms=110,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=120,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2850,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2850,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=1,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=16,
		.iCONFIG_PANEL_TYPE=1,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_SAMSUNG_LSC750FF03_G_4K2K_2S_16L,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="SAMSUNG_LSC750FF03-G_4K2K_Vby1.h"
	},
	{ //Samsung_LSC750FF04-G_Panel - 18, 120Hz panel, it need to confirm with MEMC chip
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=1228,
		.iCONFIG_DISPLAY_CLOCK_MIN=960,
		.iCONFIG_DISPLAY_REFRESH_RATE=120,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=1188*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=20,
		.iLVDS_TO_LIGHT_ON_ms=1010,

		.iLIGHT_TO_LDVS_OFF_ms=110,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=120,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2850,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2850,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=1,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=16,
		.iCONFIG_PANEL_TYPE=1,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_SAMSUNG_LSC750FF04_G_4K2K_2S_16L,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="SAMSUNG_LSC750FF04-G_4K2K_Vby1.h"
	},
	{ //AUO_T500QVN03P7_Panel - 19
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=616,
		.iCONFIG_DISPLAY_CLOCK_MIN=528,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=70,
		.iLVDS_TO_LIGHT_ON_ms=640,

		.iLIGHT_TO_LDVS_OFF_ms=5,
		.iLVDS_TO_PANEL_OFF_ms=5,

		.iPANEL_OFF_TO_ON_ms=1000,
		.iCONFIG_BACKLIGHT_PWM_FREQ=60,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2715,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2715,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=1,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_AUO_T500QVN03P7_4K2K_2S_8L,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="AUO_T500QVN03P7_4K2K_Vby1.h"
	},
	{ //AUO_T550QVN05P6_Panel - 20
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=616,
		.iCONFIG_DISPLAY_CLOCK_MIN=528,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=70,
		.iLVDS_TO_LIGHT_ON_ms=640,

		.iLIGHT_TO_LDVS_OFF_ms=5,
		.iLVDS_TO_PANEL_OFF_ms=5,

		.iPANEL_OFF_TO_ON_ms=1000,
		.iCONFIG_BACKLIGHT_PWM_FREQ=60,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2715,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2715,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=1,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_AUO_T550QVN05P6_4K2K_2S_8L,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="AUO_T550QVN05P6_4K2K_Vby1.h"
	},
	{ //AUO_T650QVN08P7_Panel - 21 , // 120Hz panel, it need to confirm MEMC chip setting
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=1232,
		.iCONFIG_DISPLAY_CLOCK_MIN=1056,
		.iCONFIG_DISPLAY_REFRESH_RATE=120,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=1188*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=70,
		.iLVDS_TO_LIGHT_ON_ms=640,

		.iLIGHT_TO_LDVS_OFF_ms=5,
		.iLVDS_TO_PANEL_OFF_ms=5,

		.iPANEL_OFF_TO_ON_ms=1000,
		.iCONFIG_BACKLIGHT_PWM_FREQ=120,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2715,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2715,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=16,
		.iCONFIG_PANEL_TYPE=1,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_AUO_T650QVN08P7_4K2K_2S_16L,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.iPANEL_WIDTH_MM = 0,
		.iPANEL_HEIGHT_MM = 0,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0, 

		.sPanelName="AUO_T650QVN08P7_4K2K_Vby1.h"
	},
};


// old panel type for reference
#if 0
static const PANEL_CONFIG_PARAMETER panel_setting[PANEL_NUM] =
{
	{ //default_panel.h - 1
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=1,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=0,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=154,
		.iCONFIG_DISPLAY_CLOCK_MIN=126,
		.iCONFIG_DISPLAY_REFRESH_RATE=75,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=149*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=2200,
		.iCONFIG_DISP_VERTICAL_TOTAL=1125,

		.iCONFIG_DISP_HSYNC_WIDTH=31,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=140,
		.iCONFIG_DISP_DEN_END_HPOS=2060,
		.iCONFIG_DISP_DEN_STA_VPOS=16,
		.iCONFIG_DISP_DEN_END_VPOS=1096,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=1920,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=1080,

		.iCONFIG_DISP_HSYNC_LASTLINE=2199,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=240,
		.iCONFIG_BACKLIGHT_PWM_DUTY=10,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=1308,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=1380,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=1100,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=1149,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x10000,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0,
		.iCONFIG_SR_MODE=3,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=0,
		.iCONFIG_SFG_PORT_NUM=0,
		.iCONFIG_PANEL_TYPE=0,
		.iCONFIG_PANEL_CUSTOM_INDEX=0,

		.i3D_DISPLAY_TIMING=0,

	        	.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="benq22_default_panel.h"
	},
	{ //China_Star_4K2K_VBY1.h - 2
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=1,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_CHINASTAR_4K2K_600M_2S_8L,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="China_Star_4K2K_VBY1.h"
	},
	{ //Skyworth_4K2K_VBY1.h - 3
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_INX8903_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="Skyworth_Default_4K2K_VBY1.h"
	},
	{ //LG_4k2k_600M_VBY1_1Seg8Port.h - 4
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

	        	.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="LG_4K2K_600M_VBY1_1Seg8Port.h"
	},
	{ //LG_ Vby1 120hz - 5
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=120,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x89abcdef,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=1,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=16,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_120HZ_1S_16L,

		.i3D_DISPLAY_TIMING=0,

	        	.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="LG_VBY1_120Hz.h"
	},
	{ //LG_ Vby1 120hz - 6
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=120,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x89abcdef,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=1,
		.iCONFIG_SFG_SEG_NUM=4,
		.iCONFIG_SFG_PORT_NUM=16,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_120HZ_4S_16L,

		.i3D_DISPLAY_TIMING=0,

	        	.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="LG_VBY1_120Hz_4Seg16L.h"
	},
	{ //LG_4k2k_60_EPI_V16DRD_VerA.h - 7
		.iCONFIG_DISPLAY_PORT=2,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=0,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=5872,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=63,
		.iCONFIG_DISP_VSYNC_LENGTH=3,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=240,
		.iCONFIG_BACKLIGHT_PWM_DUTY=10,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x6789AB00,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x00012345,
		.iCONFIG_SR_MODE=3,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=12,
		.iCONFIG_SFG_PORT_NUM=12,
		.iCONFIG_PANEL_TYPE=P_EPI_TYPE,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_EPI_LG_65_4K2K,

		.i3D_DISPLAY_TIMING=_3D_TIMING_2K1K_60,

	        	.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="LG_4k2k_60_EPI_V16DRD_VerA.h"
	},
	{ //LG_4k2k_65_EPI.h - 7
		.iCONFIG_DISPLAY_PORT=2,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=0,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=63,
		.iCONFIG_DISP_VSYNC_LENGTH=3,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=240,
		.iCONFIG_BACKLIGHT_PWM_DUTY=10,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x6789AB00,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x00012345,
		.iCONFIG_SR_MODE=3,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=12,
		.iCONFIG_SFG_PORT_NUM=12,
		.iCONFIG_PANEL_TYPE=P_EPI_TYPE,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_EPI_LG_65_4K2K,

		.i3D_DISPLAY_TIMING=_3D_TIMING_2K1K_60,

	        	.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="LG_4K2K_65_EPI.h"
	},
    { //LG_4k2k_600M_VBY1_1Seg8Port.h - 8
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=127,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_TO_HDMI,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

	        	.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="LG_Vby1_To_HDMI.h"
	},
	 { //RTK VB1 to LVDS panel - 9
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=127,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x02020202,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x02020202,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_TO_LVDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_RTK_VB1_4K2K_TO_LVDS,

		.i3D_DISPLAY_TIMING=0,

	        .iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="RTK_Vby1_To_LVDS.h"
	},
	{ //RTK VB1 to LVDS panel - 9
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=127,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x02020202,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x02020202,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_TO_LVDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_RTK_VB1_4K2K_TO_LVDS_NEW_VER,

		.i3D_DISPLAY_TIMING=0,

	        .iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="RTK_Vby1_To_LVDS_New.h"
	},
	{ //LG_4k2k_43_EPI.h - 10
		.iCONFIG_DISPLAY_PORT=2,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=0,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=63,
		.iCONFIG_DISP_VSYNC_LENGTH=3,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=240,
		.iCONFIG_BACKLIGHT_PWM_DUTY=10,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=1,
		.i3D_LINE_ALTERNATIVE_SUPPORT=1,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=1,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x543210ba,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x98765432,
		.iCONFIG_SR_MODE=3,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=6,
		.iCONFIG_SFG_PORT_NUM=12,
		.iCONFIG_PANEL_TYPE=P_EPI_TYPE,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_EPI_LG_LC430DGG_UHD60_12LANE,

		.i3D_DISPLAY_TIMING=_3D_TIMING_2K1K_60,

	    .iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="LG_LC430DGG_UHD60_EPI_12LANE.h"
	},
	{ //LG_4k2k_43_EPI.h - 11
		.iCONFIG_DISPLAY_PORT=2,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=0,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=63,
		.iCONFIG_DISP_VSYNC_LENGTH=3,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=240,
		.iCONFIG_BACKLIGHT_PWM_DUTY=10,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=1,
		.i3D_LINE_ALTERNATIVE_SUPPORT=1,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=1,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x543210ba,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x98765432,
		.iCONFIG_SR_MODE=3,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=6,
		.iCONFIG_SFG_PORT_NUM=6,
		.iCONFIG_PANEL_TYPE=P_EPI_TYPE,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_EPI_LG_LC550EGG_UHD60_6LANE,

		.i3D_DISPLAY_TIMING=_3D_TIMING_2K1K_60,

		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="LG_LC550EGG_UHD60_EPI_6LANE.h"
	},
	{ //LG_4k2k_43_EPI.h - 12
		.iCONFIG_DISPLAY_PORT=2,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=0,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=63,
		.iCONFIG_DISP_VSYNC_LENGTH=3,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=200,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=240,
		.iCONFIG_BACKLIGHT_PWM_DUTY=10,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=1,
		.i3D_LINE_ALTERNATIVE_SUPPORT=1,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=1,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x543210ba,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x98765432,
		.iCONFIG_SR_MODE=3,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=6,
		.iCONFIG_SFG_PORT_NUM=6,
		.iCONFIG_PANEL_TYPE=P_CEDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_CEDS_LG_HV490QUB_UHD60_12LANE,

		.i3D_DISPLAY_TIMING=_3D_TIMING_2K1K_60,

		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="LG_HV490QUB_UHD60_CEDS_12LANE.h"
	},
	{ //4K mLVDS 4port_6pair- 13
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=600,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_MINI_LVDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=0,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="BOE_4K_mLVDS.h "
	},
	{ //4K mLVDS 4port_6pair- 13
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=600,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_MINI_LVDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_MINI_LVDS_CSOT_PANEL,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="CSOT_4K_mLVDS.h "
	},
	{ //4K mLVDS 4port_6pair- 13
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=600,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_MINI_LVDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_MINI_LVDS_BOE_PANEL,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="BOE_4K_mLVDS2.h "
	},
	{ //4K mLVDS 4port_6pair- 13
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=600,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_CEDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_CEDS_BOE_HV550QUB_H81_PANEL,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="CEDS_BOE_HV550QUB_H81_PANEL.h "
	},
	{ //4K mLVDS 4port_6pair- sharp
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=600,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=2,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_MINI_LVDS,
		.iCONFIG_PANEL_CUSTOM_INDEX=P_MINI_LVDS_SHARP_70_PANEL,

		.i3D_DISPLAY_TIMING=0,
		.iCONFIG_CUSTOMER_PANEL_ID=0,

		.sPanelName="SHARP_4K_70Inch_mLVDS.h "
	}
};
#endif
#else//sn panel_setting
#define PANEL_NUM 48

PANEL_CONFIG_PARAMETER_SN panel_setting[PANEL_NUM] =
{
	{ //RTK_4K2K_VBY1_1Seg8Port - 1
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="PANELLESS_4K",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 2
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			
		.sPanelName="PANELLESS_2K"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 3
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			
		.sPanelName="Reserved"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 4
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",	  

		.sPanelName="Reserved"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 5
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			

		.sPanelName="Reserved"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 6
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			
		.sPanelName="Reserved"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 7
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			

		.sPanelName="SGR_43"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 8
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			
		.sPanelName="SGR_49"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 9
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			
		.sPanelName="SGR_55"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 10
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			

		.sPanelName="SGR_65"
	},
		{ //RTK_4K2K_VBY1_1Seg8Port - 11
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			

		.sPanelName="CHL_43"
	},
		{ //RTK_4K2K_VBY1_1Seg8Port - 12
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			

		.sPanelName="CHL_49"
	},
		{ //RTK_4K2K_VBY1_1Seg8Port - 13
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			

		.sPanelName="CHL_55"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 14
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			
		.sPanelName="CHL_65"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 15
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			
		.sPanelName="KC_55"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 16
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			

		.sPanelName="KC_65"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 17
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			

		.sPanelName="NR_55_CSOT"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 18
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			

		.sPanelName="NR_65_CSOT"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 19
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			

		.sPanelName="NR_75_CSOT"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 20
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",			

		.sPanelName="NR_75_AUO"
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 21
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_21",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 22
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_22",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 23
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_23",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 24
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_24",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 25
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_25",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 26
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_26",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 27
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_27",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 28
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_28",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 29
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_29",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 30
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_30",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 31
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_31",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 32
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_32",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 33
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_33",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 34
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_34",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 35
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_35",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 36
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_36",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 37
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_37",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 38
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_38",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 39
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_39",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 40
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_40",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 41
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_41",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 42
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_42",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 43
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_43",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 44
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_44",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 45
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_45",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 46
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_46",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 47
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_47",
		
	},
	{ //RTK_4K2K_VBY1_1Seg8Port - 48
		.iCONFIG_DISPLAY_PORT=1,
		.iCONFIG_DISPLAY_COLOR_BITS=0,
		.iCONFIG_DISPLAY_EVEN_RSV1_BIT=0,
		.iCONFIG_DISPLAY_ODD_RSV1_BIT=0,
		.iCONFIG_DISPLAY_BITMAPPING_TABLE=1,
		.iCONFIG_DISPLAY_PORTAB_SWAP=1,

		.iCONFIG_DISPLAY_RED_BLUE_SWAP=0,
		.iCONFIG_DISPLAY_MSB_LSB_SWAP=0,
		.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=0,
		.iCONFIG_DISPLAY_OUTPUT_INVERSE=0,
		.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=1,
		.iCONFIG_DISPLAY_RATIO_4X3=0,

		.iCONFIG_DISPLAY_CLOCK_MAX=600,
		.iCONFIG_DISPLAY_CLOCK_MIN=590,
		.iCONFIG_DISPLAY_REFRESH_RATE=60,
		.iCONFIG_DISPLAY_CLOCK_TYPICAL=594*1000000,

		.iCONFIG_DISP_HORIZONTAL_TOTAL=4400,
		.iCONFIG_DISP_VERTICAL_TOTAL=2250,

		.iCONFIG_DISP_HSYNC_WIDTH=15,
		.iCONFIG_DISP_VSYNC_LENGTH=5,

		.iCONFIG_DISP_DEN_STA_HPOS=280,
		.iCONFIG_DISP_DEN_END_HPOS=4120,
		.iCONFIG_DISP_DEN_STA_VPOS=45,
		.iCONFIG_DISP_DEN_END_VPOS=2205,

		.iCONFIG_DISP_ACT_STA_HPOS=0,
		.iCONFIG_DISP_ACT_END_HPOS=3840,
		.iCONFIG_DISP_ACT_STA_VPOS=0,
		.iCONFIG_DISP_ACT_END_VPOS=2160,

		.iCONFIG_DISP_HSYNC_LASTLINE=4400,
		.iCONFIG_DISP_DCLK_DELAY=0,
		._iCONFIG_DISP_ACT_STA_BIOS=0x00,
		.iCONFIG_DEFAULT_DPLL_M_DIVIDER=0xb2,
		.iCONFIG_DEFAULT_DPLL_N_DIVIDER=0x18,

		.iPANEL_TO_LVDS_ON_ms=50,
		.iLVDS_TO_LIGHT_ON_ms=500,

		.iLIGHT_TO_LDVS_OFF_ms=200,
		.iLVDS_TO_PANEL_OFF_ms=40,

		.iPANEL_OFF_TO_ON_ms=1200,
		.iCONFIG_BACKLIGHT_PWM_FREQ=50,
		.iCONFIG_BACKLIGHT_PWM_DUTY=255,
		.iFIX_LAST_LINE_ENABLE=0,
		.iFIX_LAST_LINE_4X_ENABLE=0,
		.iVFLIP=0,

		.iPICASSO_CONTROL_ON=0,
		.i3D_DISPLAY_SUPPORT=0,
		.i3D_LINE_ALTERNATIVE_SUPPORT=0,
		.i3D_PR_OUTPUT_LR_SWAP=0,
		.i3D_SG_OUTPUT_120HZ_ON=0,
		.i3D_SG_24HZ_OUTPUT_FHD_ON=0,
		.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=0,

		//append new parameters 2012-3-21
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=2647,
		.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=2812,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=2213,
		.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=2288,

		.iCONFIG_LVDS_4_PORTS_INDEX=0,
		.iCONFIG_LVDS_PN_SWAP=0,
		.iCONFIG_LVDS_MIRROR=0,

		.iCONFIG_DISPLAY_PORT_CONFIG1=0x01234567,
		.iCONFIG_DISPLAY_PORT_CONFIG2=0x01234567,
		.iCONFIG_SR_MODE=0,
		.iCONFIG_SR_PIXEL_MODE=0,
		.iCONFIG_SFG_SEG_NUM=1,
		.iCONFIG_SFG_PORT_NUM=8,
		.iCONFIG_PANEL_TYPE=P_VBY1_4K2K,
		.iCONFIG_PANEL_CUSTOM_INDEX=VBY_ONE_PANEL_LG_4K2K_600M_1S_8L,

		.i3D_DISPLAY_TIMING=0,

		.iCONFIG_CUSTOMER_PANEL_ID=0,
	
		.iPANEL_WIDTH_MM = 941,
		.iPANEL_HEIGHT_MM = 529,
		.iBACKLIGHT_PWM_48HZ_FREQ = 0,
		.iBACKLIGHT_PWM_50HZ_FREQ = 0,
		.iBACKLIGHT_PWM_60HZ_FREQ = 0,
		.iPixelClk60Hz=594000000,
		.iHTotal60Hz=4400,
		.iVTotal60Hz=2252,
		.iHSyncWidth_60Hz=8,
		.iVSyncWidth_60Hz=8,
		.iHFrontPorch_60Hz=144,
		.iHbackPorch_60Hz=408,
		.iVFrontPorch_60Hz=52,
		.iVbackPorch_60Hz=32,
		
		.iPixelClk50Hz=594000000,
		.iHTotal50Hz=4640,
		.iVTotal50Hz=2560,
		.iHSyncWidth_50Hz=8,
		.iVSyncWidth_50Hz=8,
		.iHFrontPorch_50Hz=384,
		.iHbackPorch_50Hz=408,
		.iVFrontPorch_50Hz=360,
		.iVbackPorch_50Hz=32,
		
		.iPixelClk48Hz=594000000,
		.iHTotal48Hz=4640,
		.iVTotal48Hz=2668,
		.iHSyncWidth_48Hz=8,
		.iVSyncWidth_48Hz=8,
		.iHFrontPorch_48Hz=384,
		.iHbackPorch_48Hz=408,
		.iVFrontPorch_48Hz=468,
		.iVbackPorch_48Hz=32,
		.iBuf="",		
		.sPanelName="Reserved_48",
		
	}
};

#endif
